/*
**    Copyright 2019 Timur Gandzhelashvili
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ADC64CONFIGDB_H
#define ADC64CONFIGDB_H

#include "mongo/AbstractConfigDb.h"
#include "Adc64Config.h"

class Adc64ConfigDb : public AbstractConfigDb
{
    Q_OBJECT
public:
    Adc64ConfigDb(const ConfigSelector &_cs, QObject *parent);

public slots:
    void setConfig(const Adc64Config &newConfig);

signals:
    void configChanged(const Adc64Config &);

protected:
    virtual void update_config_from_db() override;

private:
    Adc64Config config;
};

#endif // ADC64CONFIGDB_H
