/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ADCSTATUSTABLEMODEL_H
#define ADCSTATUSTABLEMODEL_H

#include "base/mvc/MergeColumnsTableModel.h"

class Adc64SystemConfig;
class DeviceIndexEnabledMap;
class DeviceTableModel;
class LldpInfoCache;

class AdcStatusTableModel : public MergeColumnsTableModel
{
    Q_OBJECT

public:
    AdcStatusTableModel(QObject *parent = nullptr);
    ~AdcStatusTableModel() override;

signals:
    void lldpCacheUpdated(const LldpInfoCache &cache);
    void setDeviceList(const DeviceIndexEnabledMap &new_devices);

public slots:

private:
    Adc64SystemConfig * const config;
    DeviceTableModel * const modelA;
    DeviceTableModel * const modelB;
};

#endif // ADCSTATUSTABLEMODEL_H
