/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ADCSTATUSWIDGET_H
#define ADCSTATUSWIDGET_H

#include <QTableView>

class AdcStatusTableModel;
class Adc64SystemConfig;
class DeviceIndexEnabledMap;
class DeviceIndexFilterProxyModel;
class LldpInfoCache;

class AdcStatusWidget : public QTableView
{
    Q_OBJECT
public:
    explicit AdcStatusWidget(QWidget *parent = nullptr);

signals:
    void lldpCacheUpdated(const LldpInfoCache &cache);
    void deviceListChanged(const DeviceIndexEnabledMap &new_devices); // unused
    void setDeviceList(const DeviceIndexEnabledMap &new_devices);
    void configChanged(const Adc64SystemConfig &config); // unused

public slots:
    void setConfig(const Adc64SystemConfig &config);

private:
    AdcStatusTableModel * const model;
    DeviceIndexFilterProxyModel * const indexFilter;
};

#endif // ADCSTATUSWIDGET_H
