#include "DominoDeviceFactory.h"

#include "DominoDevice12EU050.h"
#include "DominoDeviceAD9249.h"
#include "DominoDeviceAD9252.h"
#include "DominoDeviceADS52J90.h"
#include "DominoDeviceHMCAD1101.h"
#include "DominoDeviceLtm9011.h"
#include "dominodevice.h"

DominoDevice *DominoDeviceFactory::create(const DeviceIndex &index, QObject *parent)
{
    const quint16 devId = index.getDevId();

    DominoDevice * dev;
    switch (devId) {
    case DEVICE_ID_ADC64:
        dev = new DominoDevice12EU050(index, parent);
        break;
    case DEVICE_ID_ADC64S2:
    case DEVICE_ID_ADC64WR:
    case DEVICE_ID_ADC64VE:
    case DEVICE_ID_ADC64VE_XGE:
        dev = new DominoDeviceAD9249(index, parent);
            // dev = new DominoDeviceHMCAD1101(index, parent);
        break;
    case DEVICE_ID_ADC64VE2:
    case DEVICE_ID_ADC64ECAL:
        dev = new DominoDeviceADS52J90(index, parent);
        break;
    case DEVICE_ID_ADCM163:
        dev = new DominoDeviceAD9252(index, parent);
        break;
    case DEVICE_ID_TQDC16VS_DIG:
        dev = new DominoDeviceLtm9011(index, parent);
        break;
    default:
        dev = new DominoDevice(index, parent);
        break;
    }
    return dev;
}
