/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "Adc64Config.h"

void Adc64Config::blockSparseSetup()
{
    for(DeviceIndex device_index : device_configs.keys()){
        device_configs[device_index].sparseParams.sparseAllowed = false;
    }
}


void Adc64Config::setRun(bool val)
{
    run = val;

    for(auto it=device_configs.begin(); it!=device_configs.end(); ++it)
        it->run = it->enabled && run;
}

void Adc64Config::setPeriodicalAdcDelayCheck(bool val)
{
    periodicalAdcDelayCheck = val;

    for(auto it=device_configs.begin(); it!=device_configs.end(); ++it)
        it->periodicalAdcDelayCheck = periodicalAdcDelayCheck;
}

bool Adc64Config::operator==(const Adc64Config &r) const
{
    return true &&
           run == r.run &&
           preamplifier == r.preamplifier &&
           showSparseMarkers == r.showSparseMarkers &&
           showPcbCh == r.showPcbCh &&
           adcDelayResultDir == r.adcDelayResultDir &&
           fir_map == r.fir_map &&
           device_configs == r.device_configs;
}
