/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "Adc64SystemConfigDispatcher.h"

#include "Adc64SystemConfig.h"

Adc64SystemConfigDispatcher::Adc64SystemConfigDispatcher(QObject *parent)
    : BaseConfigDispatcher(parent),
      cache(new Adc64SystemConfig())
{
    qRegisterMetaType<Adc64SystemConfig>();
}

Adc64SystemConfigDispatcher::~Adc64SystemConfigDispatcher()
{
    delete cache;
}

void Adc64SystemConfigDispatcher::setConfig(const Adc64SystemConfig &config)
{
    if (config == *cache)
        return;
    *cache = config;
    qDebug() << __PRETTY_FUNCTION__ << "config changed for " << config.device_configs.keys();
    emit configChanged(config);
}
