#ifndef ADC64SYSTEMSIGNALROUTER_H
#define ADC64SYSTEMSIGNALROUTER_H

class Adc64SystemConfigDb;
class Adc64SystemConfigDispatcher;
class ConfigurationManager;
class EvNumChecker;
class MainWindow;
class PNPServer;
class RemoteControlServer;

class Adc64SystemSignalRouter
{
public:
    void setConfigurationManager(ConfigurationManager *p)
    { configurationManager = p; }

    void setMainWindow(MainWindow *p)
    { mainWindow = p; }

    void setPnpServer(PNPServer *p)
    { pnpServer = p; }

    void setConfigDispatcher(Adc64SystemConfigDispatcher *p)
    { configDispatcher = p; }

    void setRemoteControlServer(RemoteControlServer *p)
    { remoteControl = p; }

    void setConfigDb(Adc64SystemConfigDb * p)
    { configDb = p; }

    void setEvNumChecker(EvNumChecker * p)
    { evNumChecker = p; }

    void connectAll() const;

private:
    void connect_ConfigurationDispatcher() const;
    void connect_MainWindow() const;
    void connect_PnpServer() const;
    void connect_RemoteControlServer() const;

    ConfigurationManager *configurationManager = nullptr;
    Adc64SystemConfigDispatcher * configDispatcher = nullptr;
    MainWindow *mainWindow = nullptr;
    PNPServer *pnpServer = nullptr;
    RemoteControlServer *remoteControl = nullptr;
    EvNumChecker *evNumChecker = nullptr;
    Adc64SystemConfigDb * configDb = nullptr;
};
#endif // ADC64SYSTEMSIGNALROUTER_H
