#ifndef WRDAQDIALOG_H
#define WRDAQDIALOG_H

#include <QDialog>

#include "Adc64SystemConfig.h"

namespace Ui {
class WrDaqDialog;
}

class WrDaqDialog : public QDialog
{
    Q_OBJECT

public:
    explicit WrDaqDialog(QWidget *parent = nullptr);
    ~WrDaqDialog();

    void accept() override;

signals:
    void configChanged(const Adc64SystemConfig &);

public slots:
    void setConfig(const Adc64SystemConfig &r);


private slots:
    void on_comboBoxDevice_currentIndexChanged(int index);
    void on_spinBoxBaseLine_valueChanged(int baseline);
    void on_spinBoxLevel_valueChanged(int level);
    void on_radioButtonVer1_toggled(bool checked);
    void on_radioButtonVer2_toggled(bool checked);

private:
    void apply();
    void updateCurrentDevice();
    void restore_gui_values();
    DeviceIndex getCurrentIndex() const;

    Ui::WrDaqDialog *ui;
    Adc64SystemConfig config;
    DeviceIndex curIndex;
    QMap<int, DeviceIndex> cbMap;
};

#endif // WRDAQDIALOG_H
