#ifndef ADC64SIGNALROUTER_H
#define ADC64SIGNALROUTER_H

//#include <QMap>

class Adc64ConfigDb;
class Adc64ConfigDispatcher;
class AdcSerDesCalDialog;
class ConfigurationManager;
class CopyConfigDialog;
class DeviceDispatcher;
class DiscoverDialog;
class DominoDevice;
class DominoDeviceManager;
class MainWindow;

class Adc64SignalRouter
{
    Adc64SignalRouter() = default;

public:
    // Singleton
    static Adc64SignalRouter & instance()
    {
        // thread-safe since C++11
        static Adc64SignalRouter obj;
        return obj;
    }
    // delete copy and move constructors and assign operators
    Adc64SignalRouter(Adc64SignalRouter const &) = delete;
    Adc64SignalRouter(Adc64SignalRouter &&) = delete;
    Adc64SignalRouter &operator=(Adc64SignalRouter const &) = delete;
    Adc64SignalRouter &operator=(Adc64SignalRouter &&) = delete;

//    void addClientManager(int id, ClientManager *p)
//    { clients[id] = p; }

    void setConfigurationManager(ConfigurationManager *p)
    { configurationManager = p; }

    void setMainWindow(MainWindow *p)
    { mainWindow = p; }

    void setDeviceDispatcher(DeviceDispatcher *p)
    { deviceDispatcher = p; }

    void setConfigDispatcher(Adc64ConfigDispatcher *p)
    { configDispatcher = p; }

    void setDominoDeviceManager(DominoDeviceManager *p)
    { deviceMgr = p; }

    void setConfigDb(Adc64ConfigDb * p)
    { configDb = p; }

    void setDiscoverDialog(DiscoverDialog * p)
    { discoverDialog = p; }

    void setCopyConfigDialog(CopyConfigDialog * p)
    { copyConfigDialog = p; }

    void setAdcSerDesCalDialog(AdcSerDesCalDialog * p)
    { adcSerDesCalDialog = p; }

    void connectAll();
    void connect_DominoDevice(const DominoDevice *dev);

private:
    void connect_ConfigurationDispatcher();
    void connect_DominoDeviceManager();
    void connect_DeviceDispatcher();
    void connect_lldp();
    void connect_CopyConfigDialog();

    ConfigurationManager *configurationManager = nullptr;
    Adc64ConfigDispatcher * configDispatcher = nullptr;
    MainWindow *mainWindow = nullptr;
    Adc64ConfigDb * configDb = nullptr;
    DominoDeviceManager * deviceMgr = nullptr;
    DeviceDispatcher * deviceDispatcher = nullptr;
    DiscoverDialog * discoverDialog = nullptr;
    CopyConfigDialog * copyConfigDialog = nullptr;
    AdcSerDesCalDialog * adcSerDesCalDialog = nullptr;
};
#endif // ADC64SIGNALROUTER_H
