#ifndef COPYCONFIGDIALOG_H
#define COPYCONFIGDIALOG_H

#include <QDialog>
#include <QMap>

#include "base/DeviceIndex.h"

class Adc64Config;
class QAbstractButton;

namespace Ui {
class CopyConfigDialog;
}

class CopyConfigDialog : public QDialog
{
    Q_OBJECT

public:
    explicit CopyConfigDialog(QWidget *parent = nullptr);
    ~CopyConfigDialog() override;

signals:
    void configChanged(const Adc64Config &);

public slots:
    void setConfig(const Adc64Config &r);
    void setSelectedDevice(const DeviceIndex &index);
    virtual void setVisible(bool visible) override;

private slots:
    void radioButtonToggled(bool checked);
    void checkBoxToggled(bool);
    void on_pushButtonCopy_clicked();

private:
    void restore_gui_values();
    void addLog(QString msg, bool isErr=false);
    void updateCopyButton() const;

    Ui::CopyConfigDialog * const ui;
    Adc64Config * const config;

    QMap<DeviceIndex, QPair<QAbstractButton*, QAbstractButton*> > devButtons;
    DeviceIndex from_key;
    bool guiValid = false;
};

#endif // COPYCONFIGDIALOG_H
