#ifndef PREAMPLIFIERDIALOG_H
#define PREAMPLIFIERDIALOG_H

#include <QDialog>

#include "base/DeviceIndex.h"

class Adc64Config;

namespace Ui {
class PreamplifierDialog;
}

class PreamplifierDialog : public QDialog
{
    Q_OBJECT

public:
    explicit PreamplifierDialog(Adc64Config *config, QWidget *parent = nullptr);
    ~PreamplifierDialog() override;
    void reset_gui();

signals:
    void config_changed();

public slots:
    void device_changed(DeviceIndex index);

private slots:
    void on_groupBox_toggled(bool checked);
    void on_radioButtonVersion1_toggled(bool checked);
    void on_radioButtonVersion2_toggled(bool checked);
    void on_spinBoxBaseline_valueChanged(int baseline);
    void on_spinBoxLevel_valueChanged(int level);
    void block_gui_signals(bool block);

private:
    Ui::PreamplifierDialog * const ui;
    QList<QWidget*> block_signal_widgets_list;
    Adc64Config * const config;
    DeviceIndex selected_device;
};

#endif // PREAMPLIFIERDIALOG_H
