
#include <stdexcept>

#include "mainwindow.h"
#include "adc64-common/Adc64StartupOptions.h"
#include "base/app/DaqGuiApp.h"
#include "Adc64App.h"
#include "base/app/RunGuard.h"
#include "mongo/PrintConfigMap.h"

int main(int argc, char *argv[])
{
    Adc64App daqApp(argc, argv);
    daqApp.init();

    if(daqApp.hasConfigListOpt())
        printConfigMap(daqApp.getType());

    RunGuard::runSingleOrExit(daqApp.getConfigSelector());

    int res = 1;
    try {
        MainWindow w(daqApp.getStartupOptions());
        w.show();
        res = daqApp.exec();
    }
    catch (std::runtime_error &e) {
        qFatal("%s", e.what());
        return 1;
    }
    return res;
}
