#include "Config.h"

#include <QSettings>

void Config::loadSettings()
{
    QSettings settings;

    int val;
    bool ok;
    QString hexStr = settings.value("serial").toString();
    auto serId = hexStr.toULongLong(&ok, 16);
    hexStr = settings.value("id").toString();
    auto id = hexStr.toUShort(&ok, 16);
    if (id && serId) {
        deviceIndex = DeviceIndex(static_cast<DeviceId>(id), serId);
    }
    enabled = settings.value("enabled").toBool();
    isCustom = settings.value("isCustom").toBool();
    val = settings.value("regType").toInt(&ok);
    if(ok)
        regType = static_cast<REG_TYPE>(val);
    val = settings.value("regAddr").toInt(&ok);
    if(ok)
        regAddr = static_cast<quint16>(val);
    quint64 val64 = settings.value("regWriteVal").toULongLong(&ok);
    if(ok)
        regWriteVal = val64;
}

void Config::saveSettings()
{
    QSettings settings;

    settings.setValue("serial", QString("0x%1").arg(deviceIndex.getSerial(),8,16,QChar('0')) );
    settings.setValue("id", QString("0x%1").arg(deviceIndex.getDevId(),2,16,QChar('0')));
    settings.setValue("isCustom", isCustom);
    settings.setValue("regType", regType);
    settings.setValue("regAddr", regAddr);
    settings.setValue("regWriteVal", regWriteVal);
}
