#ifndef CONFIG_H
#define CONFIG_H

#include <QString>

#include "base/DeviceIndex.h"

class ConfigBase
{
public:
    enum REG_TYPE{REG_TYPE_16=0,
                  REG_TYPE_32=1,
                  REG_TYPE_64=2};

    DeviceIndex deviceIndex;
    bool enabled = true;
    bool isCustom = false;
    REG_TYPE regType = REG_TYPE_16;
    quint16 regAddr = 0;
    quint64 regWriteVal = 0;
};

class Config : public ConfigBase
{
public:
    void loadSettings();
    void saveSettings();
};

#endif // CONFIG_H
