#include "ConfigConverter.h"

template<>
bool AbstractConfigConverter<Config>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<Config>::toJsonObject(const Config &in)
{
    QVariantMap m;
    m["rows_on_page"] = QVariant::fromValue(in.rows_on_page);
    m["page_number"] = QVariant::fromValue(in.page_number);
    return fromVariantMap(m);
}

template<>
Config AbstractConfigConverter<Config>::fromJsonObject(const QJsonObject &m)
{
    Config out;
    out.rows_on_page = QVariant::fromValue(m["rows_on_page"]).value<int>();
    out.page_number = QVariant::fromValue(m["page_number"]).value<int>();
    return out;
}

template<>
QJsonValue AbstractConfigConverter<Config>::toJsonValue(const Config &in)
{
    return toJsonObject(in);
}

template<>
Config AbstractConfigConverter<Config>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<Config>::registerSubTypes()
{}
