#include "ConfigDB.h"
#include "ConfigSerDes.h"
#include "mongo/RootConfigUtil.h"

#include "base/RcRunId.h"
#include "base/ConfigDocument.h"

#include <QJsonObject>
#include <QJsonDocument>

ConfigDB::ConfigDB(const ConfigSelector &_cs, QObject *parent) :
    AbstractConfigDb(_cs, parent),
    config(Config())
{}

void ConfigDB::setConfig(const Config &newConfig)
{
    if (newConfig == config)
        return;
    config = newConfig;
    ConfigDocument cd(getConfigSelector());
    QJsonObject obj = QVariant::fromValue(newConfig).value<QJsonObject>();
    qInfo().noquote().nospace() << QJsonDocument(obj).toJson();
    cd.setConfig(obj);
    write(cd);
}

void ConfigDB::update_config_from_db()
{
    ConfigDocument tmp = BaseConfig::read_(cs);
//    if(!tmp.isEmpty()){
//        obj = tmp;
//        config = Config();
//        ConfigSerDes::json_to_pod(obj, &config);
//        emit configChanged(config);
//    }
}

//QMap<QString, QStringList> ConfigDB::get_config_map(const DaqModule &program_type)
//{
//    return BaseConfig::get_config_map(program_type);
//}

//bool ConfigDB::delete_config(const ConfigSelector &cs)
//{
//    return BaseConfig::delete_config(cs);
//}

//void ConfigDB::write_hist(const Config &newConfig)
//{
//    config = newConfig;
//    ConfigSerDes::pod_to_json(config, &obj);
//    RcRunId run_id;
//    run_id.runIndex = "TEST";
//    run_id.runNumber = 666;
//    RootConfigUtil::pod_to_json(run_id, &obj);
//    BaseConfig::write_history_config(obj);
//}
