#include "ConfigDispatcher.h"

#include "Config.h"
#include <QDebug>

ConfigDispatcher::ConfigDispatcher(QObject *parent) :
    QObject(parent),
    cache(new Config())
{
    qRegisterMetaType<Config>();
}

ConfigDispatcher::~ConfigDispatcher()
{
    delete cache;
}

void ConfigDispatcher::setConfig(const Config &config)
{
    if (config == *cache)
        return;
    *cache = config;
    qDebug() << __PRETTY_FUNCTION__ << "config changed";
    emit configChanged(config);
}
