#ifndef CONFIGDISPATCHER_H
#define CONFIGDISPATCHER_H

#include <QObject>

class Config;

class ConfigDispatcher : public QObject
{
    Q_OBJECT
public:
    ConfigDispatcher(QObject *parent = nullptr);
    virtual ~ConfigDispatcher();

    template<class T>
    void subscribe(T *obj) {
        connect(obj, &T::configChanged,
                this, &ConfigDispatcher::setConfig);
        connect(this, &ConfigDispatcher::configChanged,
                obj, &T::setConfig);
    }

signals:
    void configChanged(const Config &);

public slots:
    void setConfig(const Config &config);

private:
    Config * const cache;
};

#endif // CONFIGDISPATCHER_H
