#ifndef JSONVIEWER_H
#define JSONVIEWER_H

#include "AbstractDbViewer.h"
#include "Config.h"

#include "mongo/JsonDB.h"
#include <QObject>
struct type;
class ConfigDocument;

class JsonViewer :  public JsonDB, public  AbstractDbViewer
{
public:
    JsonViewer();
    QList<ConfigDocument> aggregate(const Config &config);
    QList<QJsonObject> agregate_json(const Config &config) override;
    QMap<ConfigSelector, QJsonObject> agregate_cs_json(const Config &config) override;
    QMap<RcRunId, QJsonObject> agregate_ri_json(const Config &config) override;
    QList<ConfigSelector> get_config_selectors(const Config &) override;
    QStringList get_program_types(const Config &config) override;
    QStringList get_program_indexes(const Config &config) override;
    QList<RcRunId> get_rc_run_ids(const Config &config) override;
    QStringList get_rc_program_type(const Config &config) override { return QStringList(); }
};

#endif // JSONVIEWER_H
