#ifndef METADB_H
#define METADB_H

#include "mongo/BaseConfig.h"
#include "mongoqt/MongoCollection.h"
#include "base/ConfigSelector.h"
#include "base/ConfigMeta.h"
#include "base/RcRunId.h"
#include "Config.h"

#include <QList>
#include <QMetaType>
#include <QString>

#include "AbstractDbViewer.h"

class ConfigDocument;

class MongoViewer : public AbstractDbViewer, public MongoDB
{
public:
    MongoViewer();
    QList<MongoHost> get_all_hosts(const Config &config);
    QList<ConfigDocument> aggregate(const Config &config);

    QList<QJsonObject> agregate_json(const Config &config) override;
    QMap<ConfigSelector, QJsonObject> agregate_cs_json(const Config &config) override;
    QMap<RcRunId, QJsonObject> agregate_ri_json(const Config &config) override;
    QList<ConfigSelector> get_config_selectors(const Config &config) override;

    QStringList get_program_types(const Config &config) override;
    QStringList get_program_indexes(const Config &config) override;
    QList<RcRunId> get_rc_run_ids(const Config &config) override;
    QStringList get_rc_program_type(const Config &config) override;

private:
    void update_filters(const Config &config);
    QStringList all_program_types;
    QStringList all_program_indexes;
    QStringList all_run_indexes;
    QList<int> all_run_numbers;
    QList<QDateTime> all_datetimes;
};

#endif // METADB_H
