#ifndef CLIENTFSM_H
#define CLIENTFSM_H

#include "fsm/BaseFsm.h"
#include "base/ClientIndex.h"

struct ClientFsmInput : public BaseFsmInput
{
    ClientFsmInput(const ClientIndex &_index) : index(_index) {}
    ClientIndex index; // use to identify one ClientFsmInput from another
    FsmState tcpState = FsmState::Init;
    bool analizerInRun = false;
};

class ClientFsm : public BaseFsm
{
    Q_OBJECT
public:
    explicit ClientFsm(const ClientIndex &index, QObject *parent = nullptr);
    void setTcpState(FsmState tcpState);
    void setAnalizerInRun(bool analizerInRun);

protected slots:
    virtual bool evaluate() override;

protected:
    virtual qint64 stateTimeoutMs(const FsmState &state) const override;

    virtual void printInputString(QDebug dbg) const override;
    inline ClientFsmInput *getInput() {
        return static_cast<ClientFsmInput*>(BaseFsm::getInput());
    }
    inline const ClientFsmInput *getInput() const {
        return static_cast<const ClientFsmInput*>(BaseFsm::getInput());
    }
};

QDebug operator<<(QDebug dbg, const ClientFsmInput &in);
#endif // CLIENTFSM_H
