#include "EvBConfigDb.h"
#include "base/config/ConfigSelector.h"
#include "EvBConfigConverter.h"

EvBConfigDb::EvBConfigDb(const ConfigSelector &_cs, QObject *parent) :
    AbstractConfigDb(_cs, parent)
{
    AbstractConfigConverter<EvBConfig>::registerTypes();
}

void EvBConfigDb::update_config_from_db()
{
    auto conf_json = BaseConfig::read(cs);
    config = QVariant::fromValue(conf_json).value<EvBConfig>();
    emit configChanged(config);
}

void EvBConfigDb::setConfig(const EvBConfig &newConfig)
{
    if (newConfig == config)
        return;
    config = newConfig;

    auto json = QVariant::fromValue(config).value<QJsonObject>();
    write_config(json);
}
