#include "app/RunGuard.h"
#include "metric-sender/MetricSender.h"
#include "mongo/StartupOptions.h"
#include "mongo/PrintConfigMap.h"

#include "MainWindow.h"
#include "EvBApp.h"
#include <QDebug>

int main(int argc, char *argv[])
{
    EvBApp app(argc, argv);
    app.init();

    if(app.hasConfigListOpt())
        printConfigMap(app.getType());

    const auto &startupOptions = app.getStartupOptions();
    const auto &cs = startupOptions.cs;

    RunGuard::runSingleOrExit(cs.getType(), cs.getIndex());

    MetricSender::instance().install();

    MainWindow w(cs);
    w.show();

    return app.exec();
}
