#include "MscConfigDb.h"

#include <QTimer>

#include "MscConfigConverter.h"

MscConfigDb::MscConfigDb(const ConfigSelector &cs, QObject *parent):
    AbstractConfigDb(cs, parent)
{
    QTimer::singleShot(0, this, &MscConfigDb::update_config_from_db);
    AbstractConfigConverter<MscConfig>::registerTypes();
}

void MscConfigDb::setConfig(const MscConfig &newConfig)
{
    if (newConfig == config)
        return;
    config = newConfig;

    auto json = QVariant::fromValue(config).value<QJsonObject>();
    BaseConfig::write(cs, json);
}

void MscConfigDb::update_config_from_db()
{
    auto json = read(cs);
    config = QVariant::fromValue(json).value<MscConfig>();
    emit configChanged(config);
}
