#ifndef DEVICECONFIG_H
#define DEVICECONFIG_H

#include "base/DeviceIndex.h"

#include <QMap>
#include <QVector>

struct DeviceConfig
{
    DeviceConfig(const DeviceIndex &i = DeviceIndex()) : device_index(i) {}
    const static int N_CH = 16;

    DeviceIndex device_index;
    bool enabled = true;

    QMap<int, double> channel_thr_map;
    QMap<int, double> baseLine;
    QString lut_path;
    int hit_extension = 0;
};
Q_DECLARE_METATYPE(DeviceConfig)

bool operator==(const DeviceConfig &l, const DeviceConfig &r);

QDebug operator<<(QDebug dbg, const DeviceConfig &s);

#endif // DEVICECONFIG_H
