/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef MSCCONFIG_H
#define MSCCONFIG_H

#include "base/DeviceIndex.h"
#include "DeviceConfig.h"

#include <QMap>

class MscConfig
{
public:
    friend bool operator==(const MscConfig &l, const MscConfig &r)
    {
        return l.hit_extension == r.hit_extension &&
                l.show_log == r.show_log &&
                l.device_configs == r.device_configs;
    }

    int hit_extension = 0;
    bool show_log = true;
    QMap<DeviceIndex, DeviceConfig> device_configs;
};

Q_DECLARE_METATYPE(MscConfig)

QDebug operator<<(QDebug dbg, const MscConfig &s);

#endif // MSCCONFIG_H
