/*
**    Copyright 2014-2016 Ivan Filippov
**    Copyright 2014-2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "SpillConfig.h"

#include <QDebug>
#include <QSettings>

bool SpillConfig::operator==(const SpillConfig &rhs) const
{
    return true
            && durPhase1 == rhs.durPhase1
            && durPhase2 == rhs.durPhase2
            && durPhase3 == rhs.durPhase3
            && durPhase4 == rhs.durPhase4
            && durPhase5 == rhs.durPhase5
            && source == rhs.source
            && softSpill == rhs.softSpill
            && timerPeriod == rhs.timerPeriod
            && spillPlotStep == rhs.spillPlotStep
            && trigTimeStep == rhs.trigTimeStep
            ;
}

QDebug operator <<(QDebug stream, const SpillConfig &spill)
{
    stream.noquote().nospace()
        << "SpillConfig("
        << "phase 1: " << spill.durPhase1
        << ", phase 2: " << spill.durPhase2
        << ", phase 3: " << spill.durPhase3
        << ", phase 4: " << spill.durPhase4
        << ", phase 5: " << spill.durPhase5
        << ", timer period: " << spill.timerPeriod
        << ", source select: " << spill.source
        << ")";
    return stream;
}
