/*
**    Copyright 2014-2018 Ivan Filippov
**    Copyright 2014-2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TRIGCONFIG_H
#define TRIGCONFIG_H

#include <QMetaType>
#include <QtGlobal>

class QDebug;
class QSettings;

class TrigConfig
{
public:
    enum {TrigMaskTimer = 0x8000, TrigMaskRandom = 0x4000, TrigMaskLvds = 0x2000};
    bool operator==(const TrigConfig &ref) const;

    quint16 xOffMask = 0;
    bool trigOpen = true;
    quint16 trigSrc = 1;
    double trigTimerFreq = 1000.0;  // Hz
    double trigRandomFreq = 1000.0; // Hz
    double trigRandomDeadTimeUs = 10.0; // us
};

Q_DECLARE_METATYPE(TrigConfig)

QDebug operator <<(QDebug stream, const TrigConfig &trig);

#endif // TRIGCONFIG_H
