#ifndef DEVICEGLOB_H
#define DEVICEGLOB_H

#include "TdcDevice.h"
#include "QElapsedTimer"

class QSemaphore;
class QThread;

#include "mstream-lib/MStreamDump.h"

class TcpClient;

class DeviceGlob : public QObject
{
    Q_OBJECT
public:
    DeviceGlob(const DeviceIndex &i, bool debug);
    virtual ~DeviceGlob();
    void startThreads();
    QColor getColor() const;

public slots:
    void deleteDevice(DeviceIndex i);

public:
    DeviceIndex index;
    TDCDevice * dev;
    QThread * devThread;
    MStreamDump * mstream = nullptr;
    QThread * msThread;
    QElapsedTimer lastMStreamActivity;
    TdcStatus lastDevStatus;
    TdcStatus pendingDevStatus;
    quint32 setup_index = 0;
    bool dev_online = false;
    bool dev_warn = false;
    QVector<bool> warn_flags;
    MStreamStat msStat;
    QMap<int, QString> tbl_info_log;
};

#endif // DEVICEGLOB_H
