#ifndef TDCSIGNALROUTER_H
#define TDCSIGNALROUTER_H

class ConfigurationManager;
class DeviceMgrFsm;
class TdcConfigDb;
class TdcConfigDispatcher;
class MainWindow;
class PNPServer;
class RemoteControlServer;
class EvNumChecker;

class TdcSignalRouter
{
public:
    void setConfigurationManager(ConfigurationManager *p)
    { configurationManager = p; }
    void setMainWindow(MainWindow *p)
    { mainWindow = p; }
    void setPnpServer(PNPServer *p)
    { pnpServer = p; }
    void setConfigDispatcher(TdcConfigDispatcher *p)
    { tdcConfigDispatcher = p; }
    void setConfigDb(TdcConfigDb *p)
    { tdcConfigDb = p; }
    void setRemoteControlServer(RemoteControlServer *p)
    { remoteControlServer = p; }
    void setEvNumChecker(EvNumChecker *p)
    { evNumChecker = p; }
    void setFsm(DeviceMgrFsm *p)
    { fsm = p; }

    void connectAll() const;

private:
    void connect_ConfigurationDispatcher() const;
    void connect_PnpServer() const;
    void connect_RemoteControlServer() const;

    ConfigurationManager *configurationManager = nullptr;
    TdcConfigDb * tdcConfigDb = nullptr;
    TdcConfigDispatcher * tdcConfigDispatcher = nullptr;
    MainWindow *mainWindow = nullptr;
    PNPServer *pnpServer = nullptr;
    RemoteControlServer *remoteControlServer = nullptr;
    EvNumChecker *evNumChecker = nullptr;
    DeviceMgrFsm *fsm = nullptr;
//    QMap<int, ClientManager*> clients; // stored by client's id
};

#endif // TDCSIGNALROUTER_H
