#ifndef TDCSTATISTIC_H
#define TDCSTATISTIC_H

#include <QString>
#include "mregdev/HwipError.h"

struct TdcStatistic
{
    TdcStatistic() {
        powerOnErrCnt.clear();
        clear();
    }
    void clear() {
        fwWithNewCnt=false;
        evNumCandidateRun=0;
        evNumAccepted=0;
        evNumBlocked=0;
        run_time=0;
        busy_total=0;
        busy_tdc=0;
        busy_readout=0;
//        timeValidLoss=0;
//        rxCodeError=0;
//        pllUnlockCnt=0;
    }
    QString getBusyStr(bool full, const TdcStatistic &st = TdcStatistic()) const;
    QString getBusyTotalStr(const TdcStatistic &st = TdcStatistic()) const;
    QString getBusyTdcStr(const TdcStatistic &st = TdcStatistic()) const;
    QString getBusyReadoutStr(const TdcStatistic &st = TdcStatistic()) const;
    double getBusyTotal(const TdcStatistic &st = TdcStatistic()) const;
    double getBusyTdc(const TdcStatistic &st = TdcStatistic()) const;
    double getBusyReadout(const TdcStatistic &st = TdcStatistic()) const;
    quint64 getBlocked() const {return fwWithNewCnt ? evNumBlocked : (evNumCandidateRun-evNumAccepted);}
    QString getRunTime() const;
    quint64 getRunTimeSec() const;

    bool fwWithNewCnt;
    quint64 evNumCandidateRun;
    quint64 evNumAccepted;
    quint64 evNumBlocked;
    quint64 run_time;
    quint64 busy_total;
    quint64 busy_tdc;
    quint64 busy_readout;
//    quint32 timeValidLoss;
//    quint32 rxCodeError;
//    quint32 pllUnlockCnt;
    HwipError errCnt;
    HwipError powerOnErrCnt;
};
#endif // TDCSTATISTIC_H
