#ifndef TDCCONFIG_H
#define TDCCONFIG_H

#include <QString>
#include <QMap>
#include <QMetaType>

#include "TdcDeviceConfig.h"

#include "base/DeviceIndex.h"
#include "base/RcRunId.h"
#include "mongo/BaseConfig.h"
#include "mongo/StartupOptions.h"

struct TdcConfig
{
    TdcConfig() = default;
    TdcConfig(const TdcConfig &r) = default;
    bool operator==(const TdcConfig &r) const;

    TdcDeviceConfig &getConfig(const DeviceIndex &index);
    TdcDeviceConfig getCurrentConfig();
    bool isRun() const;
    bool has_enabled_device() const;
    DeviceIndex get_device_index_by_key(QString key) const;

    bool run = false;
    bool remote_start_request = false;
    bool mstreamShowTable = true;
    bool mstreamShowLog = true;
    bool global_mode = true;
    bool trace_device_info = false;
    bool show_power_current = false;
    QString configFileName;
    bool allow_remote_control = true;
    int sort_column = -1;
    bool sort_asc = true;
    bool show_cfg_widget = true;

    RcRunId runId; // todo move to program status (MW)
    DeviceIndex curDev; // index for enabled selected device // TODO take out
    QMap<DeviceIndex, TdcDeviceConfig> known_configs;
    TdcDeviceConfig default_device_config; // allow to store last cfg even if knownSetups is empty
};
Q_DECLARE_METATYPE(TdcConfig)

#endif // TDCCONFIG_H
