#include "TdcConfigDb.h"

#include "base/ConfigSelector.h"

#include "TdcConfig.h"
#include "TdcConfigDispatcher.h"
#include "TdcConfigConvertor.h"

TdcConfigDb::TdcConfigDb(const ConfigSelector &_cs, QObject *parent) :
    AbstractConfigDb(_cs, parent),
    tdc_config(new TdcConfig())
{
    AbstractConfigConverter<TdcConfig>::registerTypes();
}

TdcConfigDb::~TdcConfigDb()
{
}

void TdcConfigDb::setConfig(const TdcConfig &newConfig)
{
    if (newConfig == *tdc_config)
        return;
    *tdc_config = newConfig;

    auto json = QVariant::fromValue(*tdc_config).value<QJsonObject>();
    auto ret = write(cs, json);
    if(!ret)
        qWarning() << __PRETTY_FUNCTION__ << "write failed";
}

void TdcConfigDb::update_config_from_db()
{
    auto json = read(cs);
    *tdc_config = QVariant::fromValue(json).value<TdcConfig>();
    tdc_config->run= false;
    tdc_config->default_device_config.run = false;
    for(auto &ds : tdc_config->known_configs)
        ds.run = false;
    emit configChanged(*tdc_config);
}
