#ifndef TDCCONFIGDB_H
#define TDCCONFIGDB_H

#include "mongo/AbstractConfigDb.h"

#include <memory>

class ConfigSelector;
class TdcConfig;

class TdcConfigDb : public AbstractConfigDb
{
    Q_OBJECT
public:
    TdcConfigDb(const ConfigSelector &_cs, QObject *parent = nullptr);
    ~TdcConfigDb() override;

signals:
    void configChanged(const TdcConfig &);

public slots:
    void setConfig(const TdcConfig &newConfig);

protected:
    void update_config_from_db() override final;

private:
    std::unique_ptr<TdcConfig> tdc_config;
};

#endif // TDCCONFIGDB_H
