#ifndef TDCCONFIGDISPATCHER_H
#define TDCCONFIGDISPATCHER_H

#include "base/BaseConfigDispatcher.h"

#include "TdcConfig.h"

class TdcConfigDispatcher : public BaseConfigDispatcher
{
    Q_OBJECT
public:
    TdcConfigDispatcher(QObject *parent = nullptr);
    virtual void sendCache() const override {
        BaseConfigDispatcher::sendCache();
        emit configChanged(*cache);
    }

    template<class T>
    void subscribe(T *obj) {
        connect(obj, &T::configChanged,
                this, &TdcConfigDispatcher::setConfig);
        connect(this, &TdcConfigDispatcher::configChanged,
                obj, &T::setConfig);
        qDebug() << "TdcConfig:"
                 << metaObject()->className()
                 << "<->"
                 << obj->metaObject()->className();
    }

signals:
    void configChanged(const TdcConfig &) const;

public slots:
    void setConfig(const TdcConfig &config);

private:
    std::unique_ptr<TdcConfig> cache;
};

#endif // TDCCONFIGDISPATCHER_H
