#include "TdcDeviceConfig.h"

#include <QSettings>
#include <QBitArray>

TdcDeviceConfig::TdcDeviceConfig()
{
    trigsetup.all = 0;
}

bool TdcDeviceConfig::operator<(const TdcDeviceConfig &r) const {
    return index<r.index;

    if(order_index == -1) {
        if(r.order_index == -1) {
            return index.getSerial() < r.index.getSerial();
        } else {
            return true;
        }
    } else {
        if(r.order_index == -1) {
            return true;
        } else {
            if(order_index == r.order_index)
                return index.getSerial() < r.index.getSerial();
            else
                return order_index < r.order_index;
        }
    }
}

bool TdcDeviceConfig::operator==(const TdcDeviceConfig &r) const
{
    return true &&
           enabled == r.enabled &&
           index == r.index &&
           order_index == r.order_index &&
           setup_index == r.setup_index &&
           run == r.run &&
           chTdcEn == r.chTdcEn &&
           latency == r.latency &&
           matchWin == r.matchWin &&

           hptdcHdr == r.hptdcHdr &&
           hptdcTrl == r.hptdcTrl &&
           leadEdge == r.leadEdge &&
           trailEdge == r.trailEdge &&
           stat_readout == r.stat_readout &&
           stat_period == r.stat_period &&
           trigPeriod == r.trigPeriod &&
           pll_bypass == r.pll_bypass &&
           trigsetup == r.trigsetup &&
           adjust_set == r.adjust_set &&
           stat_preset == r.stat_preset;
}

void TdcDeviceConfig::setNCh(int n)
{
    bool defTdcEn = chTdcEn.empty() ? true : chTdcEn.first();
    for(int ch=0; ch<n; ++ch) {
        if(!chTdcEn.contains(ch))
            chTdcEn[ch] = defTdcEn;
    }
    nch = n;
}

StatPreset StatPresetFabric::getPreset(int type)
{
    StatPreset sp;
    switch (type) {
    case StatPreset::STAT_DEFAULT:
        return sp;
    case StatPreset::STAT_DEBUG:
    {
        sp.type = (StatPreset::STAT_TYPE)type;
        sp.label = "debug";
        sp.regs << 0x0226;
        return sp;
    }
    case StatPreset::STAT_Test:
    {
        sp.type = (StatPreset::STAT_TYPE)type;
        sp.label = "test";
        sp.regs.clear();
        sp.regs << 0x0227;
        return sp;
    }
    default:
        return sp;
    }
}

QList<StatPreset> StatPresetFabric::getAllPresets()
{
    QList<StatPreset> all_presets;
    for(int i=0; i<StatPreset::STAT_PRESET_CNT; ++i)
        all_presets << getPreset(i);
    return all_presets;
}

bool operator==(const reg_trig_ctrl &l, const reg_trig_ctrl &r) {
    return l.all == r.all;
}
