#include "MainWindow.h"
#include "base/app/DaqGuiApp.h"
#include "base/app/RunGuard.h"
#include "metric-sender/MetricSender.h"
#include "mongo/StartupOptions.h"

int main(int argc, char *argv[])
{
    DaqGuiApp daqApp(argc, argv, DaqModule::Type::TdcControl);
    daqApp.init();

    StartupOptions startup_options(daqApp.getType());
    startup_options.parse_options();

    const auto &program_index = startup_options.cs.getIndex();
    RunGuard::runSingleOrExit(startup_options.cs.getType(), program_index);

    int res =1;
    MetricSender::instance().install();

    MainWindow w(startup_options);

    w.show();
    res = daqApp.exec();

    return res;
}
