#ifndef DEVICECHTREEVIEW_H
#define DEVICECHTREEVIEW_H

#include <QTreeView>

class QSettings;

class DeviceIndex;
class SpinBoxDelegate;

class DeviceChTreeView : public QTreeView
{
public:
    explicit DeviceChTreeView(QWidget *parent = nullptr);
    void setModel(QAbstractItemModel *model) override;
    void saveAppGuiSettings(QSettings &) const;
    void loadAppGuiSettings(const QSettings &);

private slots:
    void expanded(const QModelIndex &index);
    void collapsed(const QModelIndex &index);
    void onModelReset();

public slots:
    void expandTopItem();

private:
    DeviceIndex getDeviceIndex(const QModelIndex &index) const;
    void addDelegate(const QModelIndex &parent = QModelIndex());

    QMap<DeviceIndex, bool> expand_device_map;
    SpinBoxDelegate * const delegate;

};

#endif // DEVICECHTREEVIEW_H
