#ifndef SPINBOXDELEGATE_H
#define SPINBOXDELEGATE_H

#include "TqdcConfig.h"

#include <QItemDelegate>

struct DeviceChModelItem;
class QSpinBox;

class SpinBoxDelegate : public QItemDelegate
{
Q_OBJECT
public:
    SpinBoxDelegate(QObject *parent = 0);
    QWidget *createEditor(QWidget *parent,
                          const QStyleOptionViewItem &option,
                          const QModelIndex &index) const;
    void setEditorData(QWidget *editor,
                       const QModelIndex &index) const;
    void setModelData(QWidget *editor,
                      QAbstractItemModel *model,
                      const QModelIndex &index) const;
    void updateEditorGeometry(QWidget *editor,
                              const QStyleOptionViewItem &option,
                              const QModelIndex &index) const;

    static void initSpinBox(QSpinBox *s);

private slots:
    void dataChanged();
    void flushCommitData();

private:
    inline DeviceChModelItem *getItemByIndex(const QModelIndex &index) const;

    QTimer * const commitDataTimer;
    QObject * commitDataWidget = nullptr;
};

#endif // SPINBOXDELEGATE_H
