#ifndef TQDCSTATUS_H
#define TQDCSTATUS_H

#include <QMetaType>
#include <QMap>

#include "base/DeviceIndex.h"
#include "device-modules/WrStatus/WrStatus.h"
#include "device-modules/TdcCore/TdcCoreStatus.h"

struct TqdcStatistic
{
    void clear() {
        evNumAll=0;
        evNumCandidateRun=0;
        evNumAccepted=0;
        timeValidLoss=0;
        rxCodeError=0;
        pllUnlockCnt=0;
    }

    quint64 evNumAll;
    quint64 evNumCandidateRun;
    quint64 evNumAccepted;
    quint32 timeValidLoss;
    quint32 rxCodeError;
    quint32 pllUnlockCnt;
};

struct TqdcStatus
{
    TqdcStatus() :
        mstreamMultiAck(false),
        mstreamHwBufSize(8)
    {
        clear();
    }
    void clear() {
        statistic.clear();
        status=0;
        adcStatus=0;
        adcSelfTestOk = false;
        connected = false;
        runFinished=true;
    }

    DeviceIndex index;
    QString fwStr; // Reg 0x56/0x57, FW_VER/FW_REV, 16-bit, firmware version/revision number, RO
    quint16 mcuVer;
    quint16 mcuRev;
    bool connected;
    bool runFinished;
    QMap<int, double> temp;
    quint16 status; // 0x2 TM Time Valid
    WrStatus wrStatus;
    quint16 adcStatus;
    bool adcSelfTestOk;
    quint16 pllStatus;
    bool mstreamMultiAck;
    quint8 mstreamHwBufSize;
    QMap<int, double> hitRate;
    HptdcStatus hptdcStatus[2];
    quint16 busyStatus;

    TqdcStatistic statistic;
};
Q_DECLARE_METATYPE(TqdcStatus)

#endif // TQDCSTATUS_H
