#ifndef TQDCTHRESHOLDMODULE_H
#define TQDCTHRESHOLDMODULE_H

#include "device-modules/Ad5328/Ad5328Module.h"

#include "device-utils/DacHelper.h"

class TqdcThresholdModule : public Ad5328Module
{
public:
    TqdcThresholdModule(QtMregDevice * const _dev);

    mlink::RegOpVector setChThresholdRegOp(const QMap<int, int> &chThr_mV,
                                           const QMap<int, int> &thrOffset,
                                           const QMap<int, bool> &chInv) const;
    int getChipCnt() const override { return 2; }

protected:
    virtual AFI_SDB_ID getSdbId() const override { return AFI_SDB_AD5328_x2_SPI; }
};

template<>
int DacConverter<TqdcThresholdModule>::getDacDefaultZero();

template<>
double DacConverter<TqdcThresholdModule>::getVRef();

#endif // TQDCTHRESHOLDMODULE_H
