#ifndef CONFIG_H
#define CONFIG_H

#include <QMetaType>
#include <QString>

#include "DeviceConfig.h"

class StartupOptions;
class QDebug;
class DeviceIndexEnabledMap;

struct TqdcConfig
{
    TqdcConfig() = default;
    DeviceIndexEnabledMap getDeviceIndexEnabledMap() const;

    bool isRun() const;
    void setRunState(bool run);
    int getSimilarThreshold() const;
    void setThreshold(int thr);
    bool hasEnabledDevices() const;

    bool separateChEn = false;
    bool showAllWrInfo = false;
    bool matchWinLimitEn = true;
    QMap<DeviceIndex, DeviceConfig> knownConfigs;
    DeviceConfig defaultSetup;
    bool allowRemoteControl = true;
};
Q_DECLARE_METATYPE(TqdcConfig)

inline bool operator==(const TqdcConfig &l, const TqdcConfig &r)
{
    return l.separateChEn == r.separateChEn &&
            l.showAllWrInfo == r.showAllWrInfo &&
            l.matchWinLimitEn == r.matchWinLimitEn &&
            l.knownConfigs == r.knownConfigs &&
            l.defaultSetup == r.defaultSetup &&
            l.allowRemoteControl == r.allowRemoteControl;
}

QDebug operator<<(QDebug dbg, const TqdcConfig &s);
QDataStream &operator<<(QDataStream &out, const TqdcConfig &r);
QDataStream &operator>>(QDataStream &in, TqdcConfig &r);
#endif // CONFIG_H
