#include "TqdcConfigDb.h"

#include "TqdcConfigConverter.h"

TqdcConfigDb::TqdcConfigDb(const ConfigSelector &_cs, QObject *parent):
    AbstractConfigDb(_cs, parent)
{
    AbstractConfigConverter<TqdcConfig>::registerTypes();
}

void TqdcConfigDb::setConfig(int config_key, const TqdcConfig &newConfig)
{
    Q_UNUSED(config_key);
    if(!initialized)
        return;
    if (newConfig == config)
        return;
    config = newConfig;

    auto json = QVariant::fromValue(config).value<QJsonObject>();
    write_config(json);
}

void TqdcConfigDb::update_config_from_db()
{
    auto json = read(cs);
    config = QVariant::fromValue(json).value<TqdcConfig>();
    config.setRunState(false);
    emit configChanged(config);
}
