#include "MainWindow.h"
#include "TqdcApp.h"
#include "TqdcCore.h"

#include "mongo/PrintConfigMap.h"

int main(int argc, char *argv[])
{
    TqdcApp daqApp(argc, argv);
    daqApp.init();

    if(daqApp.hasConfigListOpt())
        printConfigMap(daqApp.getType());

    const auto &cs = daqApp.getConfigSelector();

    MainWindow *mw = nullptr;
    if(daqApp.isGuiApp()) {
        mw = new MainWindow(cs);
        mw->show();
    }
    TqdcCore core(cs, mw);

    return daqApp.exec();
}
