#include "StatPreset.h"

StatPreset StatPresetFabric::getPreset(int type)
{
    StatPreset sp;
    sp.type = static_cast<StatPreset::STAT_TYPE>(type);
    switch (type) {
    case StatPreset::STAT_DEBUG:
    {
        sp.label = "debug";
//        sp.regs << 0x0226;
        return sp;
    }
    case StatPreset::STAT_Test:
    {
        sp.label = "test";
        sp.regs.clear();
//        sp.regs << 0x0227;
        return sp;
    }
    case StatPreset::STAT_DEFAULT:
    default :
        return StatPreset();
    }
}

StatPreset StatPresetFabric::getPreset(const QString &label)
{
    if(!label.isEmpty()) {
        for(auto p : StatPresetFabric::getAllPresets()) {
            if(p.label == label)
                return p;
        }
    }
    return StatPreset();
}

QList<StatPreset> StatPresetFabric::getAllPresets()
{
    QList<StatPreset> all_presets;
    for(int i=0; i<StatPreset::STAT_PRESET_CNT; ++i)
        all_presets << getPreset(i);
    return all_presets;
}
