#ifndef TTVXSCONFIGDB_H
#define TTVXSCONFIGDB_H

#include "mongo/AbstractConfigDb.h"
#include "TtvxsAppConfig.h"
#include "base/DeviceIndexEnabled.h"

class TtvxsConfigDb : public AbstractConfigDb
{
    Q_OBJECT
public:
    TtvxsConfigDb(const ConfigSelector &cs, QObject *parent = nullptr);

signals:
    void configChanged(const TtvxsAppConfig &config);
    void deviceListChanged(const DeviceIndexEnabledMap &map);

public slots:
    void setConfig(int config_key, const TtvxsAppConfig &newConfig);

protected:
    void update_config_from_db() override;

private:
    TtvxsAppConfig config;
    DeviceIndexEnabledMap map;
};

#endif // TTVXSCONFIGDB_H
