
#include "MainWindow.h"
#include "base/app/DaqGuiApp.h"
#include "base/app/RunGuard.h"
#include "metric-sender/MetricSender.h"
#include "mongo/StartupOptions.h"
#include "mongo/PrintConfigMap.h"
#include "base/Globals.h"

#include <iostream>

int main(int argc, char *argv[])
{
    DaqGuiApp daqApp(argc, argv, DaqModule::Type::Ttvxs);
    daqApp.init();

    if(daqApp.hasConfigListOpt())
        printConfigMap(daqApp.getType());

    int res = 1;
    try{
        StartupOptions startup_options(daqApp.getType());
        startup_options.parse_options();
        const auto cs = startup_options.cs;

        RunGuard::runSingleOrExit(cs.getType(), cs.getIndex().toString());
        MetricSender::instance().install();

        MainWindow w(cs);
        w.show();
        res = daqApp.exec();
    } catch (std::exception &e) {
        std::cerr << "Exception: " << e.what () << std::endl;
    }

    return res;
}
