#include "AfiViewerConfigDb.h"

#include <QLoggingCategory>

#include "AfiViewerConfigConverter.h"

AfiViewerConfigDb::AfiViewerConfigDb(const AfiViewerStartupOptions &_startupOptions, QObject *parent):
    AbstractConfigDb(_startupOptions.cs, parent),
    startupOptions(_startupOptions)
{
    AbstractConfigConverter<AfiViewerConfig>::registerTypes();
}

void AfiViewerConfigDb::setConfig(const AfiViewerConfig &newConfig)
{
    if (newConfig == config)
        return;
    config = newConfig;

    auto json = QVariant::fromValue(config).value<QJsonObject>();
//    auto cs_json = QVariant::fromValue(cs).value<QJsonObject>();
//    auto it = cs_json.begin();
//    while(it != cs_json.end()) {
//        json.insert(it.key(), it.value());
//        ++it;
//    }
    write_config(json);
}

void AfiViewerConfigDb::update_config_from_db()
{
    auto json = read(cs);
    config = QVariant::fromValue(json).value<AfiViewerConfig>();
    if(!startupOptions.fileName.isNull() && !startupOptionsUpplied) {
        config.source = AfiViewerConfig::SOURCE_DATA::SOURCE_FILE;
        config.file_reader_config.lastFile = startupOptions.fileName;
        startupOptionsUpplied = true;
    }
    config.hist_manager_config.init(getType(), startupOptions.inl);
    config.hist_manager_config.makeConfigValid();

    emit configChanged(config);
}
