#ifndef AFIVIEWERSIGNALROUTER_H
#define AFIVIEWERSIGNALROUTER_H

class ConfigurationManager;
class AfiViewerConfigDb;
class AfiViewerConfigDispatcher;
class MainWindow;
class PNPServer;
class RemoteControlServer;
class HistWorker;
class HistMngrWidget;
class ZmqDialog;
class ZmqPublisher;

class AfiViewerSignalRouter
{
public:
    void setConfigurationManager(ConfigurationManager *p)
    { configurationManager = p; }

    void setMainWindow(MainWindow *p)
    { mainWindow = p; }

    void setZmqPublisher(ZmqPublisher *p)
    { zmqPublisher = p; }

    void setZmqDialog(ZmqDialog *p)
    { zmqDialog = p; }

    void setPnpServer(PNPServer *p)
    { pnpServer = p; }

    void setConfigDispatcher(AfiViewerConfigDispatcher *p)
    { configDispatcher = p; }
    void setConfigDb(AfiViewerConfigDb *p)
    { configDb = p; }

    void setRemoteControlServer(RemoteControlServer *p)
    { remoteControlServer = p; }

    void setHistWorker(HistWorker *p)
    { histWorker = p; }

    void setHistWidget(HistMngrWidget *p)
    { histMngrWidget = p; }

    void connectAll();

private:
    void connect_MainWindow();
    void connect_PnpServer();
    void connect_ConfigurationDispatcher();
    void connect_HistWorker();
    void connect_HistWidget();
    void connect_ZMQ();

    ConfigurationManager *configurationManager = nullptr;
    AfiViewerConfigDb * configDb = nullptr;
    AfiViewerConfigDispatcher * configDispatcher = nullptr;
    MainWindow *mainWindow = nullptr;
    ZmqPublisher *zmqPublisher = nullptr;
    ZmqDialog *zmqDialog = nullptr;
    PNPServer *pnpServer = nullptr;
    RemoteControlServer *remoteControlServer = nullptr;
    HistWorker *histWorker = nullptr;
    HistMngrWidget *histMngrWidget = nullptr;
};

#endif // AFIVIEWERSIGNALROUTER_H
