#ifndef BASECONFIGDISPATCHER_H
#define BASECONFIGDISPATCHER_H

#include <QObject>
#include <QDebug>

#include <memory>

#include "base/ConfigIndexName.h"

class BaseConfigDispatcher : public QObject
{
    Q_OBJECT
public:
    explicit BaseConfigDispatcher(QObject *parent = nullptr) :
        QObject(parent),
        cacheCIN(new ConfigIndexName())
    {}

    virtual void sendCache() const {
        emit switch_to_config(*cacheCIN);
    }

    template<class T>
    void subscribeCS(T *obj) {
            connect(this, &BaseConfigDispatcher::switch_to_config,
                    obj, &T::configSelectorChanged,
                    Qt::UniqueConnection);

            connect(obj, &T::switch_to_config,
                    this, &BaseConfigDispatcher::configSelectorChanged,
                    Qt::UniqueConnection);
            qDebug() << "ConfigIndexName:"
                     << metaObject()->className()
                     << "<->"
                     << obj->metaObject()->className();
    }
signals:
    void switch_to_config(const ConfigIndexName &conf) const;

public slots:
    void configSelectorChanged(const ConfigIndexName &cin);

private:
    std::unique_ptr<ConfigIndexName> cacheCIN;
};

#endif // BASECONFIGDISPATCHER_H
