/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "ClientConfig.h"

#include <QDataStream>

QDebug operator<<(QDebug dbg, const ClientConfig &r)
{
    dbg << "ClientConfig("
        << "id: " << r.id
        << ", daq_module: " << r.daq_module
        << ", program_index: " << r.program_index
        << ", readout: " << r.readout
        << ", evNumCheck: " << r.evNumCheck
        << ", has_vme: " << r.has_vme
        << ", protoId: " << r.protoId
    << ")";
    return  dbg;
}

QDataStream &operator<<(QDataStream &out, const ClientConfig &r)
{
    out
        << r.id
        << r.daq_module
        << r.program_index
        << r.readout
        << r.evNumCheck
        << r.has_vme
        << r.protoId;
    return out;
}

QDataStream &operator>>(QDataStream &in, ClientConfig &r)
{
    int tmp_protoId;
    in
        >> r.id
        >> r.daq_module
        >> r.program_index
        >> r.readout
        >> r.evNumCheck
        >> r.has_vme
        >> tmp_protoId;
    r.protoId = static_cast<CLIENT_PROTO_ID>(tmp_protoId);
    // TODO: error checking
    return in;
}
