#ifndef CLIENTCONFIG_H
#define CLIENTCONFIG_H

#include <QDebug>
#include <QMetaType>
#include <QString>

#include "base/DaqModule.h"

class QDataStream;

enum CLIENT_PROTO_ID {
    CLIENT_PROTO_UNKNOWN=0,
    CLIENT_PROTO_V1=1, // simple string
    CLIENT_PROTO_V2=2, // RC_MSG_CMD_OLD
    CLIENT_PROTO_V3=3, // RC_MSG_CMD
};
Q_DECLARE_METATYPE(CLIENT_PROTO_ID)

struct ClientConfig {

    bool hasVme() const {
        return has_vme || daq_module == DaqModule(DaqModule::Type::VmeDaq);
    }

    int id = -1;
    DaqModule daq_module;
    QString program_index;
    bool readout = true;
    bool evNumCheck = false;
    bool has_vme = false;
    CLIENT_PROTO_ID protoId = CLIENT_PROTO_UNKNOWN;
};

Q_DECLARE_METATYPE(ClientConfig)

inline bool operator==(const ClientConfig &l, const ClientConfig &r)
{
    return l.id == r.id &&
        l.daq_module == r.daq_module &&
        l.program_index == r.program_index &&
        l.readout == r.readout &&
        l.evNumCheck == r.evNumCheck &&
        l.has_vme == r.has_vme;
}

QDebug operator<<(QDebug dbg, const ClientConfig &r);
QDataStream &operator<<(QDataStream &out, const ClientConfig &r);
QDataStream &operator>>(QDataStream &in, ClientConfig &r);

#endif // CLIENTCONFIG_H
