/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef GLOBALS_H
#define GLOBALS_H

#include <QString>

class Globals
{
public:
    static Globals &instance() {
        static Globals obj;
        return obj;
    }
    static bool getDebugMode() {
        return instance().debug_mode;
    }
    static void setDebugMode(bool value) {
        instance().debug_mode = value;
    }


    static QString getEnvironment() {
        return instance().environment;
    }
    static void setEnvironment(const QString &value) {
        instance().environment = value;
    }
    static constexpr const char *organizationName = "AFI Electronics";
    static constexpr const char *organizationDomain = "local";
    static constexpr const char *common_settings_app_name = "Common";
private:
    bool debug_mode = false;
    QString environment;
};

#endif // GLOBALS_H
