#ifndef FPGA_MCU_REGS_ADDR
#define FPGA_MCU_REGS_ADDR

// MCU SPI Slave
enum {
    REG_BMC_BASE               = 0x4000,
    REG_BMC_DEV_ID             = REG_BMC_BASE + 0x00,
    REG_BMC_ONBOARD_PLL_STATUS = REG_BMC_BASE + 0x01,
    REG_BMC_PLL_UNLOCK_CNT     = REG_BMC_BASE + 0x02, // [12:0] - unlock counter
    REG_BMC_TEMP_1             = REG_BMC_BASE + 0x03, // pll temp
    REG_BMC_TEMP_2             = REG_BMC_BASE + 0x04, // hptdc_group_a temp
    REG_BMC_TEMP_3             = REG_BMC_BASE + 0x05, // hptdc_group_b temp
    REG_BMC_TEMP_4             = REG_BMC_BASE + 0x06, // hptdc_group_c temp
    REG_BMC_VERSION            = REG_BMC_BASE + 0x08,
    REG_BMC_REVERSION          = REG_BMC_BASE + 0x09,
    REG_BMC_SYSTEM_STATUS      = REG_BMC_BASE + 0x0A, // [1:0] - 0: unknown, 1: normal, 2: warning, 3: critical
    REG_BMC_POWER_STATUS       = REG_BMC_BASE + 0x0B,
    REG_BMC_PLL_STATUS         = REG_BMC_BASE + 0x0C,

    REG_BMC_VOL_TDC_A          = REG_BMC_BASE + 0x10, // mV
    REG_BMC_CUR_TDC_A          = REG_BMC_BASE + 0x11, // mA
    REG_BMC_VOL_TDC_B          = REG_BMC_BASE + 0x12,
    REG_BMC_CUR_TDC_B          = REG_BMC_BASE + 0x13,
    REG_BMC_VOL_TDC_C          = REG_BMC_BASE + 0x14,
    REG_BMC_CUR_TDC_C          = REG_BMC_BASE + 0x15,

    REG_BMC_VOL_BP_5           = REG_BMC_BASE + 0x10, // Backplane +5V supply voltage, mV
    REG_BMC_CUR_BP_5           = REG_BMC_BASE + 0x11, // Backplane +5V supply current, mA
    REG_BMC_VOL_BP_33          = REG_BMC_BASE + 0x12, // Backplane +3.3V supply voltage, mV
    REG_BMC_CUR_BP_33          = REG_BMC_BASE + 0x13, // Backplane +3.3V supply current, mA

    REG_BMC_VOL_TDC_D          = REG_BMC_BASE + 0x1A,
    REG_BMC_CUR_TDC_D          = REG_BMC_BASE + 0x1B,
};

#endif // FPGA_MCU_REGS_ADDR
