#include "DeviceDescription.h"

DeviceDescription::DeviceDescription(const LldpInfo &r)
    : lldp(r)
{
    discoverTimer.start();
}

bool DeviceDescription::isOutOfDate() const
{
    return !discoverTimer.isValid() || discoverTimer.elapsed() > (int)getLldpInfo().ttl*1000;
}

bool DeviceDescription::isOutOfDate(const QElapsedTimer &other) const
{
    return !discoverTimer.isValid() || discoverTimer.msecsTo(other) > (int)getLldpInfo().ttl*1000;
}

bool DeviceDescription::operator ==(const DeviceDescription &dd) const
{
    return getLldpInfo() == dd.getLldpInfo() &&
            discoverTimer == dd.discoverTimer;
}
