#ifndef DEVICEDESCRIPTION_H
#define DEVICEDESCRIPTION_H

#include <QElapsedTimer>
#include <QMetaType>
#include <QString>

#include "LldpInfo.h"

class DeviceDescription
{
public:
    DeviceDescription() = default;
    DeviceDescription(const LldpInfo &r);

    const LldpInfo &getLldpInfo() const { return lldp; }

    bool isOutOfDate() const;
    bool isOutOfDate(const QElapsedTimer &other) const;
    bool operator ==(const DeviceDescription &dd) const;

    qint64 elapsed() const {
        return discoverTimer.elapsed();
    }
    qint64 elapsed(const QElapsedTimer &other) const {
        return discoverTimer.msecsTo(other);
    }

private:
    LldpInfo lldp;
    QElapsedTimer discoverTimer;
};

Q_DECLARE_METATYPE(DeviceDescription)

#endif // DEVICEDESCRIPTION_H
