#ifndef AD5328MODULE_H
#define AD5328MODULE_H

#include "device-modules/BaseDeviceModule.h"

// SPI control under DAC AD5308/AD5318/AD5328
class Ad5328Module : public BaseDeviceModule
{
public:
    Ad5328Module(quint16 bAddr, QtMregDevice * const _dev);
    Ad5328Module(QtMregDevice * const _dev) : Ad5328Module(0, _dev) {}
    void post_init() override { resetDac(); }
    bool isDoubleGain() const { return useDoubleGain; }
    virtual int getChipCnt() const = 0;
    inline int getChipCh() const {
        const int DAC_CH_PER_CHIP = 8;
        return DAC_CH_PER_CHIP;
    }

    mlink::RegOpVector setChDacDataRegOp(const QMap<int, int> &chDacData) const;

protected:
    virtual AFI_SDB_ID getSdbId() const override { return AFI_SDB_UNKNOWN; } // AFI_SDB_AD5328_x2_SPI use addr rang def from ctor

private:
    void resetDac();

protected:
    bool useDoubleGain=false;
};

#endif // AD5328MODULE_H
