#ifndef ADCCOREMODULE_H
#define ADCCOREMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include "AdcCoreStatus.h"

class AdcCoreModule : public BaseDeviceModule
{
public:
    AdcCoreModule(QtMregDevice * const dev);
    void post_init() override { readBuildParams(); }
    AdcCoreStatus getStatus() const  { return status; }
    mlink::RegOpVector getChannelDataRegOp() const;
    QVector<quint16> getChannelData();
    void setTestPatternAndEnable(quint16 pattern);
    void setPatternTestEn(bool en);
    quint64 getPatternTestCount();
    quint64 getPatternTestFailedChWithStop();
    quint64 getPatternTestFailedChWithPause();
    mlink::RegOpVector setAdcChEnRegOp(quint64 mask);
    mlink::RegOpVector setModeRegOp(bool zsEn);
    mlink::RegOpVector setLat(quint16 lat);
    mlink::RegOpVector setMatchWin(quint16 matchWin);
    mlink::RegOpVector setPreWin(quint16 preWin);
    mlink::RegOpVector setAdcWin(quint16 adcWin);
    AdcPatternStatus readPatternStatus();

protected:
    AFI_SDB_ID getSdbId() const final { return AFI_SDB_ADC_Core; }

private:
    void readBuildParams();

    AdcCoreStatus status;
};

#endif // ADCCOREMODULE_H
