#ifndef ADCSPIADS52J90MODULE_H
#define ADCSPIADS52J90MODULE_H

#include "device-modules/AdcSpiBaseModule.h"

class AdcSpiAds52J90Module : public AdcSpiBaseModule
{
public:
    AdcSpiAds52J90Module(QtMregDevice *qtMregDevice = nullptr);

    void setupAdc(quint8 adcBits, quint8 adcChPerChip=16);
    void setCustomPatternMode(bool mode) override;
    void setCustomPattern(quint16 data) override;

protected:
    AFI_SDB_ID getSdbId() const final { return AFI_SDB_UNKNOWN; }

private:
    void spi_write(quint16 addr, quint16 data, quint16 device_mask);
    quint16 spi_read(quint16 addr, quint16 device_mask);
    void spi_test();
};

#endif // ADCSPIADS52J90MODULE_H
