#ifndef ADCSPIBASEMODULE_H
#define ADCSPIBASEMODULE_H

#include "device-modules/BaseDeviceModule.h"

class AdcSpiBaseModule : public BaseDeviceModule
{
public:
    AdcSpiBaseModule(QtMregDevice *qtMregDevice = nullptr)
        : BaseDeviceModule(qtMregDevice)
    {}
    void setAdcChips(quint16 chips) { adcChips=chips; }

    virtual void setCustomPatternMode(bool mode) = 0;
    virtual void setCustomPattern(quint16 data) = 0;

protected:
    inline quint16 getAdcMask() const { return (1<<adcChips)-1; }

    int adcChips = 0;
};

#endif // ADCSPIBASEMODULE_H
