#ifndef ADCSPILTM9011MODULE_H
#define ADCSPILTM9011MODULE_H

#include "device-modules/AdcSpiBaseModule.h"

class AdcSpiLtm9011Module : public AdcSpiBaseModule
{
public:
    AdcSpiLtm9011Module(QtMregDevice *qtMregDevice = nullptr)
        : AdcSpiBaseModule(qtMregDevice)
    {}

    void setupAdc(quint8 adcBits);
    void setCustomPatternMode(bool mode) override;
    void setCustomPattern(quint16 data) override;

protected:
    AFI_SDB_ID getSdbId() const final { return AFI_SDB_LTM9011_x2_SPI; }

private:
    inline int getWriteReg(quint8 adcId = 0) const;
    inline int getAddrReg(quint8 adcId = 0) const;

    void spi_write(quint16 addr, quint16 data, quint8 adcId) const;
    quint16 spi_read(quint16 addr, quint8 adcId) const;
    void spi_test();
};

#endif // ADCSPILTM9011MODULE_H
