#ifndef BMCSTATUS_H
#define BMCSTATUS_H

#include <QtCore>


struct BmcStatus
{
    // 14-bit signed value, 1/16 degrees Celsius
    static double decodeTemp_v1(qint32 val)
    {
        val &= 0x1FFF;
        val = (val << 19) >> 19;
        return val / 32.0;
    }

    QMap<int, double> getTemp(int tempIdOffset=0) const {
        QMap<int, double> v;
        for(int i=0; i<4; ++i) {
            if(temp[i] != 0xFFFF)
                v[i+tempIdOffset] = decodeTemp_v1(temp[i]);
        }
        return v;
    }

    quint16 fw_ver;
    quint16 pllStatus;
    quint16 pllUnlockCnt;
    quint16 temp[4];
    quint16 temp1;
    quint16 temp2;
    quint16 temp3;
    quint16 temp4;
    quint16 fw_rev;
};

#endif // BMCSTATUS_H
