#ifndef ADCSERDESDELAY_H
#define ADCSERDESDELAY_H

#include <QMap>
#include <QMetaType>

#include "base/DeviceIndex.h"

struct AdcSerDesDelay
{
    int clock = 0;
    int data = 0;
};
Q_DECLARE_METATYPE(AdcSerDesDelay)

inline bool operator==(const AdcSerDesDelay &l, const AdcSerDesDelay &r)
{
    return l.clock == r.clock &&
        l.data == r.data;
}
inline bool operator!=(const AdcSerDesDelay &l, const AdcSerDesDelay &r)
{
    return !(l == r);
}

QDebug operator<<(QDebug dbg, const AdcSerDesDelay &s);
QDataStream &operator<<(QDataStream &out, const AdcSerDesDelay &r);
QDataStream &operator>>(QDataStream &in, AdcSerDesDelay &r);

typedef QMap<int, AdcSerDesDelay> DevSerDesDelay;
Q_DECLARE_METATYPE(DevSerDesDelay)

typedef QMap<DeviceIndex, DevSerDesDelay> DevSerDesDelayMap;
Q_DECLARE_METATYPE(DevSerDesDelayMap)

#endif // ADCSERDESDELAY_H
