#include "AdcSerDesDelayConvertor.h"

#include "base/ConfigConverterUtil.h"
#include "base/DeviceIndexConverter.h"

#include "AdcSerDesDelay.h"

// --------- AdcSerDesDelay

template<>
bool AbstractConfigConverter<AdcSerDesDelay>::classIsObject()
{
    return false;
}

template<>
QJsonObject AbstractConfigConverter<AdcSerDesDelay>::toJsonObject(const AdcSerDesDelay &)
{Q_UNREACHABLE();}

template<>
AdcSerDesDelay AbstractConfigConverter<AdcSerDesDelay>::fromJsonObject(const QJsonObject &)
{Q_UNREACHABLE();}

template<>
QJsonValue AbstractConfigConverter<AdcSerDesDelay>::toJsonValue(const AdcSerDesDelay &in)
{
    return QJsonArray{in.clock,in.data};
}

template<>
AdcSerDesDelay AbstractConfigConverter<AdcSerDesDelay>::fromJsonValue(const QJsonValue &in)
{
    const auto &arr = in.toArray();
    return {arr.first().toInt(),arr.last().toInt()};
}

template<>
void AbstractConfigConverter<AdcSerDesDelay>::registerSubTypes()
{
}

// -------------- DevSerDesDelay
template<>
bool AbstractConfigConverter<DevSerDesDelay>::classIsObject()
{
    return true;
}

template<>
QJsonValue AbstractConfigConverter<DevSerDesDelay>::toJsonValue(const DevSerDesDelay &in)
{
    return ConfigConverterUtil::toJsonValue(in);
}

template<>
QJsonObject AbstractConfigConverter<DevSerDesDelay>::toJsonObject(const DevSerDesDelay &in)
{
    return toJsonValue(in).toObject();
}

template<>
DevSerDesDelay AbstractConfigConverter<DevSerDesDelay>::fromJsonObject(const QJsonObject &in)
{
    const auto &map = ConfigConverterUtil::toMap<int, AdcSerDesDelay>(in);
    return map;
}

template<>
DevSerDesDelay AbstractConfigConverter<DevSerDesDelay>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());

}

template<>
void AbstractConfigConverter<DevSerDesDelay>::registerSubTypes()
{
    AbstractConfigConverter<AdcSerDesDelay>::registerTypes();
}


// -------------- DevSerDesDelayMap
template<>
bool AbstractConfigConverter<DevSerDesDelayMap>::classIsObject()
{
    return true;
}

template<>
QJsonValue AbstractConfigConverter<DevSerDesDelayMap>::toJsonValue(const DevSerDesDelayMap &in)
{
    return ConfigConverterUtil::toJsonValue(in);
}

template<>
QJsonObject AbstractConfigConverter<DevSerDesDelayMap>::toJsonObject(const DevSerDesDelayMap &in)
{
    return toJsonValue(in).toObject();
}

template<>
DevSerDesDelayMap AbstractConfigConverter<DevSerDesDelayMap>::fromJsonObject(const QJsonObject &in)
{
    const auto &map = ConfigConverterUtil::toMap<DeviceIndex, DevSerDesDelay>(in);
    return map;
}

template<>
DevSerDesDelayMap AbstractConfigConverter<DevSerDesDelayMap>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());

}

template<>
void AbstractConfigConverter<DevSerDesDelayMap>::registerSubTypes()
{
    AbstractConfigConverter<DevSerDesDelay>::registerTypes();
}
