#ifndef HITCOREMODULE_H
#define HITCOREMODULE_H

#include "device-modules/BaseDeviceModule.h"

struct HitCoreStatus;

class HitCoreModule : public BaseDeviceModule
{
public:
    HitCoreModule(QtMregDevice * const dev);
    mlink::RegOpVector setChInvertRegOp(quint64 chInv) const;
    mlink::RegOpVector getChHitCounterRegOp(int nCh=64) const;
    HitCoreStatus getHitStatus(const mlink::RegOpVector &regRes, int posOffset) const;
    mlink::RegOpVector getCmpStateRegOp() const;

protected:
    AFI_SDB_ID getSdbId() const final { return AFI_SDB_Input_Hit_Counters; }
};

#endif // HITCOREMODULE_H
