#ifndef HITCORESTATUS_H
#define HITCORESTATUS_H

#include <QVector>

struct HitCoreStatus
{
    constexpr const static double CLOCK_RATE = 125e6;
    constexpr const static double CLOCK_RATE_PHOS = 1e9;
    QVector<double> getChRate(const HitCoreStatus &prev) const {
        const double &rate = getRate();
        QVector<double> rates;

        if(prev.chCnt.size() == chCnt.size() && ts && prev.ts) {
            rates.resize(chCnt.size());
            const quint64 dt = ts - prev.ts;
            for(int ch=0; ch<chCnt.size(); ++ch)
                rates[ch] = dt ? (rate*(chCnt[ch]-prev.chCnt[ch])/dt) : 0;
        }

        return rates;
    }
    double getTimeDiff(const HitCoreStatus &prevSt) const {
        return getRate() * (ts - prevSt.ts);
    }
    double getRate() const { return isPhos ? CLOCK_RATE_PHOS : CLOCK_RATE; }

    QVector<quint32> chCnt;
    quint64 ts = 0;
    bool isPhos = false;
};

#endif // HITCORESTATUS_H
