#ifndef TDCCORECONFIG_H
#define TDCCORECONFIG_H

#include <QMetaType>

struct HptdcAdjustConfig {
    inline bool operator!=(const HptdcAdjustConfig &s) const {
        return
        readout_fifo_size != s.readout_fifo_size ||
        mode_rc_compression != s.mode_rc_compression ||
        leading_resolution != s.leading_resolution ||
        enable_pair != s.enable_pair ||
        dll_mode != s.dll_mode ||
        dll_clock != s.dll_clock ||
        core_clock_source != s.core_clock_source;
    }
    bool operator==(const HptdcAdjustConfig &r) const { return !operator!=(r); }

    quint8 readout_fifo_size = 7;       // REG32_TDC_READ_CTRL
    bool mode_rc_compression = true;    // REG32_TDC_MEASURE_CTRL
    quint16 leading_resolution = 0;     // REG32_TDC_MEASURE_CTRL
    bool enable_pair = false;           // REG32_TDC_MEASURE_CTRL
    quint16 dll_mode = 2;               // REG32_TDC_MEASURE_CTRL
    quint16 dll_clock = 3;              // REG32_TDC_MEASURE_CTRL
    quint16 core_clock_source = 1;      // REG32_TDC_MEASURE_CTRL
};
Q_DECLARE_METATYPE(HptdcAdjustConfig)

QDebug operator<<(QDebug dbg, const HptdcAdjustConfig &s);
QDataStream &operator<<(QDataStream &out, const HptdcAdjustConfig &r);
QDataStream &operator>>(QDataStream &in, HptdcAdjustConfig &r);



class TdcCoreConfig
{
public:
    TdcCoreConfig();
};

#endif // TDCCORECONFIG_H
