#include "TdcCoreConfigConvertor.h"

#include "base/ConfigConverterUtil.h"

#include "TdcCoreConfig.h"

namespace {
// --------- AdjustConfig
constexpr const char *k_readout_fifo_size = "readout_fifo_size";
constexpr const char *k_mode_rc_compression = "mode_rc_compression";
constexpr const char *k_leading_resolution = "leading_resolution";
constexpr const char *k_enable_pair = "enable_pair";
constexpr const char *k_dll_mode = "dll_mode";
constexpr const char *k_dll_clock = "dll_clock";
constexpr const char *k_core_clock_source = "core_clock_source";
}


// --------- AdjustConfig

template<>
bool AbstractConfigConverter<HptdcAdjustConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<HptdcAdjustConfig>::toJsonObject(const HptdcAdjustConfig &in)
{
    QVariantMap m;

    m[k_readout_fifo_size] = QVariant::fromValue(in.readout_fifo_size);
    m[k_mode_rc_compression] = QVariant::fromValue(in.mode_rc_compression);
    m[k_leading_resolution] = QVariant::fromValue(in.leading_resolution);
    m[k_enable_pair] = QVariant::fromValue(in.enable_pair);
    m[k_dll_mode] = QVariant::fromValue(in.dll_mode);
    m[k_dll_clock] = QVariant::fromValue(in.dll_clock);
    m[k_core_clock_source] = QVariant::fromValue(in.core_clock_source);

    return fromVariantMap(m);
}

template<>
HptdcAdjustConfig AbstractConfigConverter<HptdcAdjustConfig>::fromJsonObject(const QJsonObject &in)
{
    HptdcAdjustConfig out;

    update_value(in, k_readout_fifo_size, &out.readout_fifo_size );
    update_value(in, k_mode_rc_compression, &out.mode_rc_compression );
    update_value(in, k_leading_resolution, &out.leading_resolution );
    update_value(in, k_enable_pair, &out.enable_pair );
    update_value(in, k_dll_mode, &out.dll_mode );
    update_value(in, k_dll_clock, &out.dll_clock );
    update_value(in, k_core_clock_source, &out.core_clock_source );

    return out;
}

template<>
QJsonValue AbstractConfigConverter<HptdcAdjustConfig>::toJsonValue(const HptdcAdjustConfig &in)
{
    return toJsonObject(in);
}

template<>
HptdcAdjustConfig AbstractConfigConverter<HptdcAdjustConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<HptdcAdjustConfig>::registerSubTypes()
{
}
