#ifndef TRIGCTRLSTATMODULE_H
#define TRIGCTRLSTATMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include "TrigStatus.h"

class TrigCtrlStatModule : public BaseDeviceModule
{
public:
    TrigCtrlStatModule(QtMregDevice * const dev);
    mlink::RegOpVector setCtrlRegOp(quint16 regVal) const;
    mlink::RegOpVector setTrigSrcRegOp(quint16 regVal) const;
    mlink::RegOpVector setTimerPeriodRegOp(quint32 regVal) const;
    mlink::RegOpVector setSelfTrigDelayRegOp(quint16 regVal) const;
    mlink::RegOpVector setSelfTrigChMaskRegOp(quint64 regVal) const;
    mlink::RegOpVector resetEvNumAndStatsRegOp(quint64 evNumLoad=1) const;
    mlink::RegOpVector getStatusRegOp() const;
    TrigStatus getStatus(const mlink::RegOpVector &regRes, int posOffset=0) const;

protected:
    AFI_SDB_ID getSdbId() const final { return AFI_SDB_UNKNOWN; }
};

#endif // TRIGCTRLSTATMODULE_H
