#ifndef WRSTATUSMODULE_H
#define WRSTATUSMODULE_H

#include "device-modules/BaseDeviceModule.h"
#include "regio/regop.h"

struct WrStatus;

class WrStatusModule : public BaseDeviceModule
{
public:
    WrStatusModule(QtMregDevice * const dev);
    virtual void post_init() override;

    mlink::RegOpVector getStatusRegOp() const;
    WrStatus readStatus() const;
    WrStatus getStatus(const mlink::RegOpVector &regRes, int posOffset) const;

protected:
    AFI_SDB_ID getSdbId() const final { return AFI_SDB_WR_STATUS; }
};

#endif // WRSTATUSMODULE_H
