#ifndef DACCALIBRATION_H
#define DACCALIBRATION_H

#include <QMap>

class QtMregDevice;
class HitCoreModule;
class Ad5328Module;

namespace mlink {
class RegOpVector;
}

class DacCalibration
{
public:
    DacCalibration(QtMregDevice * const dev,
                   HitCoreModule * const hitCore,
                   Ad5328Module * const thresholdModule);
    QMap<int, int> calibrateDac();
    void setNCh(int n_ch) { nCh = n_ch; }

private:
    QVector<bool> getChStates(const mlink::RegOpVector &cmpStRegOp);

    QtMregDevice * const dev;
    HitCoreModule * const hitCore;
    Ad5328Module * const thresholdMod;

    int nCh = 0;
    const int num_samples = 20;
    bool minFound = false;
    bool maxFound = false;
};

#endif // DACCALIBRATION_H
