#ifndef HPTDCADJUSTDIALOG_H
#define HPTDCADJUSTDIALOG_H

#include <QDialog>

#include "device-modules/TdcCore/TdcCoreConfig.h"

namespace Ui {
class HptdcAdjustDialog;
}


class HptdcAdjustDialog : public QDialog
{
    Q_OBJECT
public:
    explicit HptdcAdjustDialog(QWidget *parent = nullptr);
    ~HptdcAdjustDialog();

signals:
    void adjustConfigChanged(const HptdcAdjustConfig &);

public slots:
    void setAdjustConfig(const HptdcAdjustConfig &s);
    void activate_dialog();

private slots:
    void on_comboBox_readout_fifo_currentIndexChanged(int index);
    void on_checkBox_rc_compression_clicked(bool checked);
    void on_comboBoxLeadRes_currentIndexChanged(int index);
    void on_checkBox_pairing_mode_clicked(bool checked);
    void on_comboBox_dll_mode_currentIndexChanged(int index);
    void on_comboBox_dll_clock_currentIndexChanged(int index);
    void on_comboBox_core_clock_source_currentIndexChanged(int index);
    void on_pushButton_OK_clicked();

private:
    void write_setup();

    Ui::HptdcAdjustDialog *ui;
    HptdcAdjustConfig adjust_set;
    int block_write = 0;
};

#endif // HPTDCADJUSTDIALOG_H
