#ifndef FELINKSTATUSDIALOG_H
#define FELINKSTATUSDIALOG_H

#include <QDialog>

#include "base/DeviceIndexEnabled.h"

#include "FeLink/FeLinkStatus.h"
#include "FeLinkStatusModel.h"
#include "mldiscover/LldpDiscovery.h"

namespace Ui {
class FeLinkStatusDialog;
}

class QTableView;

class FeLinkStatusDialog : public QDialog
{
    Q_OBJECT

public:
    explicit FeLinkStatusDialog(QWidget *parent = nullptr);
    ~FeLinkStatusDialog();

signals:
    void selectedDeviceChanged(const DeviceIndex &);
    void deviceListChanged(const DeviceIndexEnabledMap &);

public slots:
    void setDeviceList(const DeviceIndexEnabledMap &devices_);
    void setMasterList(const DeviceIndexSet &devices_);
    void setFeLinkStatus(const DeviceIndex &readerIndex, const QMap<int, FeLinkStatus> &st);

private:
    void removeMaster(const DeviceIndexSet &setToDel);
    void addMaster(const DeviceIndex &index);
    DeviceIndexSet getMasterSet(QMap<DeviceIndex, QMap<int, FeLinkStatus> > feLinkStatusMap);
    void updateMasterList();

    Ui::FeLinkStatusDialog *ui;
    DeviceIndexSet readerDeviceSet;
    DeviceIndexSet masterDevices;
    QMap<DeviceIndex, QMap<int, FeLinkStatus> > feLinkStatusMap; // by readerDevice
//    QMap<DeviceIndex, QList<FeLinkStatus> > feLinkStatusMap; // by masterDevice
    QMap<DeviceIndex, QTableView*> tableViewMap;
    QMap<DeviceIndex, FeLinkStatusModel*> modelMap;
    LldpInfoCache lldpCache;
};

#endif // FELINKSTATUSDIALOG_H
