#ifndef FELINKSTATUSMODEL_H
#define FELINKSTATUSMODEL_H

#include <QAbstractTableModel>

struct FeLinkStatus;

class FeLinkStatusTable;

class FeLinkStatusModel : public QAbstractTableModel
{
    Q_OBJECT
public:
    FeLinkStatusModel(QObject *parent = nullptr);
    ~FeLinkStatusModel();

    virtual int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    virtual int columnCount(const QModelIndex &parent = QModelIndex()) const override;

    virtual QVariant data(const QModelIndex &index, int role) const override;
    virtual QVariant headerData(int section, Qt::Orientation orientation,
                                int role = Qt::DisplayRole) const override;

public slots:
    void setStatusList(const QList<FeLinkStatus> &statusList_);

private:
    void invalidateCol(int slot);
    QVariant data_BackgroundRole(const FeLinkStatus &st, int row) const;
    QVariant data_DisplayRole(const FeLinkStatus &st, int row) const;
    QVariant data_ToolTipRole(const FeLinkStatus &st, int row) const;

    QList<FeLinkStatus> * const statusList;
};

#endif // FELINKSTATUSMODEL_H
