#ifndef FELINKREGS_H
#define FELINKREGS_H

// FE-Link V1.0 CSR
enum {
    REG_FELINK_CTRL                  = 0x00, // R/W
    REG_FELINK_STATUS                = 0x01, // RO
    REG_FELINK_RX_BITSLIDE           = 0x02, // RO
    REG_FELINK_REMOTE_VER            = 0x03, // RO
    REG64_FELINK_REMOTE_ID           = 0x04, // RO
    REG_FELINK_SYNC_RESEND_TIME      = 0x08, // R/W
    REG_FELINK_TIME_FRAME_TIMEOUT    = 0x09, // R/W
    REG32_FELINK_TAI_NSEC            = 0x0A, // RO
    REG64_FELINK_TAI_SEC             = 0x0C, // RO
    REG32_FELINK_LINK_STATE_TIME     = 0x10, // RO
    REG32_FELINK_CNT_RX_CODE_ERROR   = 0x14, // RO
    REG32_FELINK_CNT_RX_CRC_ERROR    = 0x16, // RO
    REG32_FELINK_CNT_TIME_FRAMES_SND = 0x18, // RO
    REG32_FELINK_CNT_TRIG_FRAMES_SND = 0x1A, // RO
    REG32_FELINK_CNT_TIME_FRAMES_RCV = 0x1C, // RO
    REG32_FELINK_CNT_TRIG_FRAMES_RCV = 0x1E, // RO
    REG32_FELINK_CNT_UNKNOWN_FRAMES  = 0x20, // RO
};

enum {
    REG_FELINK_CTRL_BIT_CNT_LOCK = 0x0002,
};

#endif // FELINKREGS_H
