#ifndef HWIPERROR_H
#define HWIPERROR_H

#include <QStringList>

struct HwipError
{
    HwipError()
    {
        clear();
    }
    void clear() {
        hwipLinkDown=0;
        regIoErr=0;
        sfpErr=0;
        hwIpErr=0;
        txErr=0;
        rxErr=0;
        txDis=0;
    }
    void operator-=(const HwipError &cnt) {
        hwipLinkDown -= cnt.hwipLinkDown;
        regIoErr -= cnt.regIoErr;
        sfpErr -= cnt.sfpErr;
        hwIpErr -= cnt.hwIpErr;
        txErr -= cnt.txErr;
        rxErr -= cnt.rxErr;
        txDis -= cnt.txDis;
    }
    QString toString() const
    {
        QStringList errCntStr;
        if(hwipLinkDown)
            errCntStr << QString("hwipLinkDown: %1").arg(hwipLinkDown);
        if(regIoErr)
            errCntStr << QString("regIoErr: %1").arg(regIoErr);
        if(sfpErr)
            errCntStr << QString("sfpErr: %1").arg(sfpErr);
        if(hwIpErr)
            errCntStr << QString("hwIpErr: %1").arg(hwIpErr);
        if(txErr)
            errCntStr << QString("txErr: %1").arg(txErr);
        if(rxErr)
            errCntStr << QString("rxErr: %1").arg(rxErr);
        return errCntStr.join('\n');
    }

    quint64 hwipLinkDown;
    quint64 regIoErr;
    quint64 sfpErr;
    quint64 hwIpErr;
    quint64 txErr;
    quint64 rxErr;
    quint64 txDis;
};

#endif // HWIPERROR_H
