#ifndef SDBTYPES_H
#define SDBTYPES_H

#include "sdb.h"

class QDebug;

static const uint64_t VENDOR_ID = 0x414649; // 'AFI'
const uint16_t MAX_SDB_DEVICE_COUNT = 32;

enum mlink_bus_type {BUS_REGIO = 1, BUS_MEMIO = 2};

struct sdb_t {
    struct sdb_interconnect ic;
    struct sdb_device device[MAX_SDB_DEVICE_COUNT];

    bool isValid() const { return ic.sdb_magic == SDB_MAGIC; }
};

QDebug operator<<(QDebug dbg, const sdb_interconnect &v);
QDebug operator<<(QDebug dbg, const sdb_device &v);
QDebug operator<<(QDebug dbg, const sdb_t &v);

#endif // SDBTYPES_H
