#ifndef ABSTRACTDB_H
#define ABSTRACTDB_H

class QDateTime;
class QJsonObject;
class QString;
template <class Key, class T> class QMap;
template <class T> class QList;

class ConfigSelector;
class ConfigDocument;
class DaqModule;
class ProgramIndex;
class RcRunId;
class ConfigurationName;

class AbstractDB
{
public:
    virtual ~AbstractDB() = default;
    virtual ConfigDocument read_(const ConfigSelector &cs) = 0;
    virtual QJsonObject read(const ConfigSelector &cs) = 0;
    virtual bool write(const ConfigDocument &cd) = 0;
    virtual bool write(const ConfigSelector &cs, const QJsonObject &obj) = 0;
    virtual bool write(const RcRunId &rc, const QJsonObject &jsonCfg) = 0;
    virtual int delete_config(const ConfigSelector &cs) = 0;
    virtual QMap<ProgramIndex, QMap<ConfigurationName, QDateTime> > get_config_map(const DaqModule &daq_module) = 0;
};

#endif // ABSTRACTDB_H
