#ifndef BASECONFIG_H
#define BASECONFIG_H

#include <QJsonObject>
#include <QObject>
#include <QString>
#include <QObject>
#include <QDateTime>
#include <QTime>

#include "JsonDB.h"

#ifdef MONGO_DRIVERS
#include "MongoDB.h"
#endif

class ConfigDocument;

class BaseConfig
{
public:
    BaseConfig();
    void init(const DaqModule &program_type);
    ConfigDocument read_(const ConfigSelector &cs);
    QJsonObject read(const ConfigSelector &cs);
    bool write(ConfigDocument &cd);
    bool write(const ConfigSelector &cs, const QJsonObject &jsonCfg);
    bool write(const RcRunId &rc, const QJsonObject &jsonCfg);
    bool delete_config(const ConfigSelector &cs);
    RcRunId check_run_number(const RcRunId &rc);
    QMap<ProgramIndex, QMap<ConfigurationName, QDateTime> > get_config_map(const DaqModule &program_type);
    #ifdef MONGO_DRIVERS
        MongoDB mongo_db;
        bool synchronization(const DaqModule &program_type);
    #endif
     JsonDB json_db;
private:
    //---debug modules
    bool type_cast_warning;
    bool mongo_alive;
};

#endif // BASECONFIG_H

