#ifndef JSONDB_H
#define JSONDB_H

#include <QString>

#include "AbstractDB.h"
//#include "JsonDB.cpp"

class QJsonObject;
class ConfigSelector;
class ConfigDocument;
struct RcRunId;
class QDateTime;
class DaqModule;

class JsonDB : public AbstractDB
{
public:
    JsonDB() = default;
    virtual ~JsonDB() override = default;
    virtual ConfigDocument read_(const ConfigSelector &cs) override;
    virtual QJsonObject read(const ConfigSelector &cs) override;
    virtual bool write(const ConfigDocument &cd) override;
    virtual bool write(const ConfigSelector &cs, const QJsonObject &obj) override;
    virtual bool write(const RcRunId &rc, const QJsonObject &jsonCfg) override;
    virtual int delete_config(const ConfigSelector &cs) override;
    virtual QMap<ProgramIndex, QMap<ConfigurationName, QDateTime> > get_config_map(const DaqModule &daq_module) override;
};

#endif // JSONDB_H
