#ifndef MongoDB_H
#define MongoDB_H

#include "AbstractDB.h"
#include "mongoqt/MongoQt.h"

class RcRunId;
class QDateTime;

class MongoDB : public MongoQt, public AbstractDB
{
public:
    MongoDB();
    virtual ~MongoDB() override = default;
    void mongo_init();
    virtual ConfigDocument read_(const ConfigSelector &cs) override;
    virtual QJsonObject read(const ConfigSelector &cs) override;
    virtual bool write(const ConfigDocument &cd_) override;
    virtual bool write(const ConfigSelector &cs, const QJsonObject &obj) override;
    virtual bool write(const RcRunId &rc, const QJsonObject &jsonCfg) override;
    virtual int delete_config(const ConfigSelector &cs) override;
    virtual QMap<ProgramIndex, QMap<ConfigurationName, QDateTime> > get_config_map(const DaqModule &daq_module) override;
    QMap<ProgramIndex, QMap<ConfigurationName, QJsonObject> > get_json_map(
        const DaqModule &daq_module);
    RcRunId check_run_number(const RcRunId &rc); //TODO: move to AbstractDB

private:
    int remove_broken_docs(const QStringList &fields_to_check);
    int remove_duplicates();
};

#endif // MongoDB_H
