#ifndef STARTUPOPTIONS_H
#define STARTUPOPTIONS_H

#include "base/ConfigSelector.h"

#include <QCommandLineParser>

class DaqModule;

class StartupOptionsParser : public QCommandLineParser
{
public:
    StartupOptionsParser(const QList<QCommandLineOption> &initialOptions = QList<QCommandLineOption>());
    static QList<QCommandLineOption> createOptions();
    void parse_options();

    QString program_version;
    bool list = false;
    bool version = false;
};

class StartupOptions
{
public:
    StartupOptions(const DaqModule &program_type);
    void parse_options();
    ConfigSelector cs;

protected:
    StartupOptionsParser parser;

private:
    void showVersion();
    void setConfig(const QString &configuration_name);
};


#endif // STARTUPOPTIONS_H
