#include "MongoHost.h"

#include "mongo/MongoDB.h"
#include "mongo/MongoConsts.h"

MongoHost::MongoHost()
{
    options["connectTimeoutMS"] = connectTimeoutMS;
    options["serverSelectionTimeoutMS"] = serverSelectionTimeoutMS;
}

MongoHost::~MongoHost()
{}

bool MongoHost::isLocal() const
{
    return (hostname == "localhost");
}

QString MongoHost::get_uri_string() const
{
    QString uri = prefix;

    if(!username.isEmpty() && !password.isEmpty()){
        uri += username + ":" + password + "@";
    }

    uri += hostname;
    if (!port.isEmpty())
        uri += ":" + port;

    if(!default_db.isEmpty() || !options.isEmpty()){
        uri += "/";
        if(!default_db.isEmpty())
            uri += default_db;
        if(!options.isEmpty()){
            uri += "?";
            QStringList list;
            for(auto it = options.cbegin(); it != options.cend(); ++it){
                QString s = it.key();
                if (s.isEmpty())
                    continue;
                if (!it.value().isEmpty())
                    s += "=" + it.value();
                list += s;
            }
            uri += list.join("&");
        }
    }
    return uri;
}
