#ifndef MONGOHOST_H
#define MONGOHOST_H

#include "MongoDatabase.h"
#include "mongoqt/MongoQt.h"
#include "mongo/MongoDB.h"

#include <QMetaType>
#include <QString>
#include <QMap>

class MongoDatabase;

class MongoHost
{
public:
    MongoHost();
    virtual ~MongoHost();
    void clear(){
        prefix.clear();
        hostname.clear();
        port.clear();
        username.clear();
        password.clear();
        default_db.clear();
        options.clear();
    }
    bool isLocal() const;
    bool isEmpty() const{
        return hostname.isEmpty();
    }
    bool operator == (const MongoHost &cred) const {
        return ((cred.prefix == prefix) &&
                (cred.hostname == hostname) &&
                (cred.port == port) &&
                (cred.username == username) &&
                (cred.password == password) &&
                (cred.default_db == default_db) &&
                (cred.options == options) &&
                (cred.databeses == databeses));
    }
    QString get_uri_string() const;

    QString prefix = "mongodb://";
    QString environment = "";
    QString hostname = "localhost";
    QString port = "27017";
    QString username = "";
    QString password = "";
    QString default_db = "admin";
    QMap<QString, QString> options;
    QList<MongoDatabase> databeses;
    bool is_set = false;
    bool is_connect = false;
};
Q_DECLARE_METATYPE(MongoHost);

#endif // MONGOHOST_H
