/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef MONGOQTPRIVATE_H
#define MONGOQTPRIVATE_H

#include <string>
#include <QObject>

#include <QString>

#ifndef Q_MOC_RUN
#include <bsoncxx/stdx/make_unique.hpp>
#include <bsoncxx/stdx/optional.hpp>

#include <mongocxx/instance.hpp>
#include <mongocxx/pool.hpp>
#endif

class MongoQt;

class MongoQtPrivate
{
public:
    MongoQtPrivate(MongoQt *q);
    virtual ~MongoQtPrivate(){};
    bool configure(const std::string &uri);
    mongocxx::pool::entry get_connection();
    bsoncxx::stdx::optional<mongocxx::pool::entry> try_get_connection();

    bool mongo_alive = false;
    bool type_cast_warning = false;

private:
    Q_DISABLE_COPY(MongoQtPrivate)
    Q_DECLARE_PUBLIC(MongoQt)

    MongoQt * const q_ptr;
};

#endif // MONGOQTPRIVATE_H
