#ifndef MSTREAMDUMPPARAMETERS_H
#define MSTREAMDUMPPARAMETERS_H

#include <QtGlobal>
#include <QHostAddress>

#include "types.h"
#include "base/DeviceIndex.h"

struct MStreamDumpParameters
{
    MStreamDumpParameters(const DeviceIndex index = DeviceIndex())
        : deviceIndex(index)
    {}
    QString logPrefix() const;
    QString getSerialIdStr(bool shortFormat=false) const;
    inline int getAcceptedRange() const { return acceptedRange; }
    void parseCommandLine();

    DeviceIndex deviceIndex;
    QHostAddress deviceAddress;
    int tcpPort = 0;
    QString fileName;
    bool bigFragId = false; // fragmentId is 16-bit length
    quint16 hwBufSize = 8;
    quint16 ackSizeLimit = 1;

    void preRunInit(bool doMetricSenderInit=false);

private:
    int acceptedRange = 0;
};

#endif // MSTREAMDUMPPARAMETERS_H
