#ifndef ZMQTYPES_H
#define ZMQTYPES_H

#include <QMetaType>

class QDataStream;
class QDebug;

// ØMQ

struct ZmqConfig
{
    bool auto_port=true;
    int port=33307;
    bool enabled=false;
    bool test_mode=false;
    bool send_all=false;
    bool print_messages=false;
};
Q_DECLARE_METATYPE(ZmqConfig)

inline bool operator==(const ZmqConfig &l, const ZmqConfig &r)
{
    return l.auto_port == r.auto_port &&
            l.port == r.port &&
            l.enabled == r.enabled &&
            l.test_mode == r.test_mode &&
            l.send_all == r.send_all &&
            l.print_messages == r.print_messages;
}

QDebug operator<<(QDebug dbg, const ZmqConfig &s);
QDataStream &operator<<(QDataStream &out, const ZmqConfig &r);
QDataStream &operator>>(QDataStream &in, ZmqConfig &r);

struct ZmqStatus
{
    int port=0; // use as return value in case of autodetect
    bool working=false;
    quint64 packages=0;
};
Q_DECLARE_METATYPE(ZmqStatus)

#endif // ZMQTYPES_H
